Loading...
Searching...
No Matches
tok.h File Reference
`#include "kernel/mod2.h"`
`#include "Singular/grammar.h"`

Go to the source code of this file.

## Macros

#define | LOGIC_OP '&'
#define | MULDIV_OP '/'
#define | COMP_OP '<'
#define | COMMAND UMINUS+2 /* in tok.h */
#define | ANY_TYPE UMINUS+3
#define | IDHDL UMINUS+4
#define | NONE END_RING
#define | UNKNOWN 0

## Enumerations

enum

{
ALIAS_CMD = UMINUS + 15 , ALIGN_CMD , ATTRIB_CMD , BAREISS_CMD ,
BIGINT_CMD , BRANCHTO_CMD , BRACKET_CMD , BREAKPOINT_CMD ,
CHARACTERISTIC_CMD , CHARSTR_CMD , CHAR_SERIES_CMD , CHINREM_CMD ,
CMATRIX_CMD , CNUMBER_CMD , CPOLY_CMD , CLOSE_CMD ,
COEFFS_CMD , COEF_CMD , COLS_CMD , CONTENT_CMD ,
CONTRACT_CMD , COUNT_CMD , CRING_CMD , DBPRINT_CMD ,
DEF_CMD , DEFINED_CMD , DEG_CMD , DEGREE_CMD ,
DELETE_CMD , DENOMINATOR_CMD , DET_CMD , DIFF_CMD ,
DIM_CMD , DIVISION_CMD , DUMP_CMD , ELIMINATION_CMD ,
END_GRAMMAR , ENVELOPE_CMD , ERROR_CMD , EXECUTE_CMD ,
EXPORTTO_CMD , EXTGCD_CMD , FAC_CMD , FAREY_CMD ,
FIND_CMD , FACSTD_CMD , FMD_CMD , FRES_CMD ,
FWALK_CMD , FGLM_CMD , FGLMQUOT_CMD , FINDUNI_CMD ,
GCD_CMD , GETDUMP_CMD , HIGHCORNER_CMD , HILBERT_CMD ,
HOMOG_CMD , HRES_CMD , IMPART_CMD , IMPORTFROM_CMD ,
INDEPSET_CMD , INSERT_CMD , INT_CMD , INTDIV_CMD ,
INTERPOLATE_CMD , INTERRED_CMD , INTERSECT_CMD , INTVEC_CMD ,
IS_RINGVAR , JACOB_CMD , JANET_CMD , JET_CMD ,
KBASE_CMD , KERNEL_CMD , KILLATTR_CMD , KRES_CMD ,
LAGSOLVE_CMD , LEAD_CMD , LEADCOEF_CMD , LEADEXP_CMD ,
LEADMONOM_CMD , LIFTSTD_CMD , LIFT_CMD , LINK_CMD ,
LIST_CMD , LOAD_CMD , LRES_CMD , LU_CMD ,
LUI_CMD , LUS_CMD , MEMORY_CMD , MINBASE_CMD ,
MINOR_CMD , MINRES_CMD , MODULO_CMD , MONITOR_CMD ,
MPRES_CMD , MRES_CMD , MRES_MAP_CMD , MSTD_CMD ,
MULTIPLICITY_CMD , NAMEOF_CMD , NAMES_CMD , NEWSTRUCT_CMD ,
NCALGEBRA_CMD , NC_ALGEBRA_CMD , NEWTONPOLY_CMD , NPARS_CMD ,
NUMERATOR_CMD , NVARS_CMD , ORD_CMD , OPEN_CMD ,
OPPOSE_CMD , OPPOSITE_CMD , OPTION_CMD , ORDSTR_CMD ,
PACKAGE_CMD , PARDEG_CMD , PARENT_CMD , PARSTR_CMD ,
PFAC_CMD , PRIME_CMD , PRINT_CMD , PRUNE_CMD ,
PRUNE_MAP_CMD , QHWEIGHT_CMD , QRING_CMD , QRDS_CMD ,
QUOTIENT_CMD , RANDOM_CMD , RANK_CMD , READ_CMD ,
REDUCE_CMD , REGULARITY_CMD , REPART_CMD , RES_CMD ,
RESERVEDNAME_CMD , RESERVEDNAMELIST_CMD , RESTART_CMD , RESULTANT_CMD ,
RIGHTSTD_CMD , RINGLIST_CMD , RING_LIST_CMD , ROWS_CMD ,
SBA_CMD , SIMPLEX_CMD , SIMPLIFY_CMD , SLIM_GB_CMD ,
SORTVEC_CMD , SQR_FREE_CMD , SRES_CMD , STATUS_CMD ,
STD_CMD , STRING_CMD , SUBST_CMD , SYSTEM_CMD ,
SYZYGY_CMD , TENSOR_CMD , TEST_CMD , TRANSPOSE_CMD ,
TRACE_CMD , TWOSTD_CMD , TYPEOF_CMD , UNIVARIATE_CMD ,
UNLOAD_CMD , URSOLVE_CMD , VANDER_CMD , VARIABLES_CMD ,
VARSTR_CMD , VDIM_CMD , WAIT1ST_CMD , WAITALL_CMD ,
WEDGE_CMD , WEIGHT_CMD , WRITE_CMD , VECHO ,
VCOLMAX , VTIMER , VRTIMER , TRACE ,
VOICE , VSHORTOUT , VPRINTLEVEL , MAX_TOK
}

## Functions

int | yyparse (void)

## Variables

EXTERN_VAR int | yylineno
EXTERN_VAR char | my_yylinebuf [80]

## Macro Definition Documentation

## ANY_TYPE

#define ANY_TYPE UMINUS+3

Definition at line 30 of file tok.h.

## COMMAND

#define COMMAND UMINUS+2 /* in tok.h */

Definition at line 29 of file tok.h.

## COMP_OP

#define COMP_OP '<'

Definition at line 27 of file tok.h.

## IDHDL

#define IDHDL UMINUS+4

Definition at line 31 of file tok.h.

## LOGIC_OP

#define LOGIC_OP '&'

Definition at line 25 of file tok.h.

## MULDIV_OP

#define MULDIV_OP '/'

Definition at line 26 of file tok.h.

## NONE

#define NONE END_RING

Definition at line 223 of file tok.h.

## UNKNOWN

#define UNKNOWN 0

Definition at line 224 of file tok.h.

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
ALIAS_CMD |
ALIGN_CMD |
ATTRIB_CMD |
BAREISS_CMD |
BIGINT_CMD |
BRANCHTO_CMD |
BRACKET_CMD |
BREAKPOINT_CMD |
CHARACTERISTIC_CMD |
CHARSTR_CMD |
CHAR_SERIES_CMD |
CHINREM_CMD |
CMATRIX_CMD |
CNUMBER_CMD |
CPOLY_CMD |
CLOSE_CMD |
COEFFS_CMD |
COEF_CMD |
COLS_CMD |
CONTENT_CMD |
CONTRACT_CMD |
COUNT_CMD |
CRING_CMD |
DBPRINT_CMD |
DEF_CMD |
DEFINED_CMD |
DEG_CMD |
DEGREE_CMD |
DELETE_CMD |
DENOMINATOR_CMD |
DET_CMD |
DIFF_CMD |
DIM_CMD |
DIVISION_CMD |
DUMP_CMD |
ELIMINATION_CMD |
END_GRAMMAR |
ENVELOPE_CMD |
ERROR_CMD |
EXECUTE_CMD |
EXPORTTO_CMD |
EXTGCD_CMD |
FAC_CMD |
FAREY_CMD |
FIND_CMD |
FACSTD_CMD |
FMD_CMD |
FRES_CMD |
FWALK_CMD |
FGLM_CMD |
FGLMQUOT_CMD |
FINDUNI_CMD |
GCD_CMD |
GETDUMP_CMD |
HIGHCORNER_CMD |
HILBERT_CMD |
HOMOG_CMD |
HRES_CMD |
IMPART_CMD |
IMPORTFROM_CMD |
INDEPSET_CMD |
INSERT_CMD |
INT_CMD |
INTDIV_CMD |
INTERPOLATE_CMD |
INTERRED_CMD |
INTERSECT_CMD |
INTVEC_CMD |
IS_RINGVAR |
JACOB_CMD |
JANET_CMD |
JET_CMD |
KBASE_CMD |
KERNEL_CMD |
KILLATTR_CMD |
KRES_CMD |
LAGSOLVE_CMD |
LEAD_CMD |
LEADCOEF_CMD |
LEADEXP_CMD |
LEADMONOM_CMD |
LIFTSTD_CMD |
LIFT_CMD |
LINK_CMD |
LIST_CMD |
LOAD_CMD |
LRES_CMD |
LU_CMD |
LUI_CMD |
LUS_CMD |
MEMORY_CMD |
MINBASE_CMD |
MINOR_CMD |
MINRES_CMD |
MODULO_CMD |
MONITOR_CMD |
MPRES_CMD |
MRES_CMD |
MRES_MAP_CMD |
MSTD_CMD |
MULTIPLICITY_CMD |
NAMEOF_CMD |
NAMES_CMD |
NEWSTRUCT_CMD |
NCALGEBRA_CMD |
NC_ALGEBRA_CMD |
NEWTONPOLY_CMD |
NPARS_CMD |
NUMERATOR_CMD |
NVARS_CMD |
ORD_CMD |
OPEN_CMD |
OPPOSE_CMD |
OPPOSITE_CMD |
OPTION_CMD |
ORDSTR_CMD |
PACKAGE_CMD |
PARDEG_CMD |
PARENT_CMD |
PARSTR_CMD |
PFAC_CMD |
PRIME_CMD |
PRINT_CMD |
PRUNE_CMD |
PRUNE_MAP_CMD |
QHWEIGHT_CMD |
QRING_CMD |
QRDS_CMD |
QUOTIENT_CMD |
RANDOM_CMD |
RANK_CMD |
READ_CMD |
REDUCE_CMD |
REGULARITY_CMD |
REPART_CMD |
RES_CMD |
RESERVEDNAME_CMD |
RESERVEDNAMELIST_CMD |
RESTART_CMD |
RESULTANT_CMD |
RIGHTSTD_CMD |
RINGLIST_CMD |
RING_LIST_CMD |
ROWS_CMD |
SBA_CMD |
SIMPLEX_CMD |
SIMPLIFY_CMD |
SLIM_GB_CMD |
SORTVEC_CMD |
SQR_FREE_CMD |
SRES_CMD |
STATUS_CMD |
STD_CMD |
STRING_CMD |
SUBST_CMD |
SYSTEM_CMD |
SYZYGY_CMD |
TENSOR_CMD |
TEST_CMD |
TRANSPOSE_CMD |
TRACE_CMD |
TWOSTD_CMD |
TYPEOF_CMD |
UNIVARIATE_CMD |
UNLOAD_CMD |
URSOLVE_CMD |
VANDER_CMD |
VARIABLES_CMD |
VARSTR_CMD |
VDIM_CMD |
WAIT1ST_CMD |
WAITALL_CMD |
WEDGE_CMD |
WEIGHT_CMD |
WRITE_CMD |
VECHO |
VCOLMAX |
VTIMER |
VRTIMER |
TRACE |
VOICE |
VSHORTOUT |
VPRINTLEVEL |
MAX_TOK |

Definition at line 33 of file tok.h.

{
ALIAS_CMD = UMINUS + 15,
ALIGN_CMD,
ATTRIB_CMD,
BAREISS_CMD,
BIGINT_CMD,
BRANCHTO_CMD,
BRACKET_CMD,
BREAKPOINT_CMD,
CHARACTERISTIC_CMD,
CHARSTR_CMD,
CHAR_SERIES_CMD,
CHINREM_CMD,
CMATRIX_CMD,
CNUMBER_CMD,
CPOLY_CMD,
CLOSE_CMD,
COEFFS_CMD,
COEF_CMD,
COLS_CMD,
CONTENT_CMD,
CONTRACT_CMD,
COUNT_CMD,
CRING_CMD,
DBPRINT_CMD,
DEF_CMD,
DEFINED_CMD,
DEG_CMD,
DEGREE_CMD,
DELETE_CMD,
DENOMINATOR_CMD,
DET_CMD,
DIFF_CMD,
DIM_CMD,
DIVISION_CMD,
DUMP_CMD,
ELIMINATION_CMD,
END_GRAMMAR,
ENVELOPE_CMD,
ERROR_CMD,
EXECUTE_CMD,
EXPORTTO_CMD,
EXTGCD_CMD,
FAC_CMD,
FAREY_CMD,
FIND_CMD,
FACSTD_CMD,
FMD_CMD,
FRES_CMD,
FWALK_CMD,
FGLM_CMD,
FGLMQUOT_CMD,
FINDUNI_CMD,
GCD_CMD,
GETDUMP_CMD,
HIGHCORNER_CMD,
HILBERT_CMD,
HOMOG_CMD,
HRES_CMD,
IMPART_CMD,
IMPORTFROM_CMD,
INDEPSET_CMD,
INSERT_CMD,
INT_CMD,
INTDIV_CMD,
INTERPOLATE_CMD,
INTERRED_CMD,
INTERSECT_CMD,
INTVEC_CMD,
IS_RINGVAR,
JACOB_CMD,
JANET_CMD,
JET_CMD,
KBASE_CMD,
KERNEL_CMD,
KILLATTR_CMD,
KRES_CMD,
LAGSOLVE_CMD,
LEAD_CMD,
LEADCOEF_CMD,
LEADEXP_CMD,
LEADMONOM_CMD,
LIFTSTD_CMD,
LIFT_CMD,
LINK_CMD,
LIST_CMD,
LOAD_CMD,
LRES_CMD,
LU_CMD,
LUI_CMD,
LUS_CMD,
MEMORY_CMD,
MINBASE_CMD,
MINOR_CMD,
MINRES_CMD,
MODULO_CMD,
MONITOR_CMD,
MPRES_CMD,
MRES_CMD,
MRES_MAP_CMD,
MSTD_CMD,
MULTIPLICITY_CMD,
NAMEOF_CMD,
NAMES_CMD,
NEWSTRUCT_CMD,
NCALGEBRA_CMD,
NC_ALGEBRA_CMD,
NEWTONPOLY_CMD,
NPARS_CMD,
NUMERATOR_CMD,
NVARS_CMD,
ORD_CMD,
OPEN_CMD,
OPPOSE_CMD,
OPPOSITE_CMD,
OPTION_CMD,
ORDSTR_CMD,
PACKAGE_CMD,
PARDEG_CMD,
PARENT_CMD,
PARSTR_CMD,
PFAC_CMD,
PRIME_CMD,
PRINT_CMD,
PRUNE_CMD,
PRUNE_MAP_CMD,
QHWEIGHT_CMD,
QRING_CMD,
QRDS_CMD,
QUOTIENT_CMD,
RANDOM_CMD,
RANK_CMD,
READ_CMD,
REDUCE_CMD,
REGULARITY_CMD,
REPART_CMD,
RES_CMD,
RESERVEDNAME_CMD,
RESERVEDNAMELIST_CMD,
RESTART_CMD,
RESULTANT_CMD,
RIGHTSTD_CMD,
RINGLIST_CMD,
RING_LIST_CMD,
ROWS_CMD,
SBA_CMD,
SIMPLEX_CMD,
SIMPLIFY_CMD,
SLIM_GB_CMD,
SORTVEC_CMD,
SQR_FREE_CMD,
SRES_CMD,
STATUS_CMD,
STD_CMD,
STRING_CMD,
SUBST_CMD,
SYSTEM_CMD,
SYZYGY_CMD,
TENSOR_CMD,
TEST_CMD,
TRANSPOSE_CMD,
TRACE_CMD,
TWOSTD_CMD,
TYPEOF_CMD,
UNIVARIATE_CMD,
UNLOAD_CMD, /* unused*/
URSOLVE_CMD,
VANDER_CMD,
VARIABLES_CMD,
VARSTR_CMD,
VDIM_CMD,
WAIT1ST_CMD,
WAITALL_CMD,
WEDGE_CMD,
WEIGHT_CMD,
WRITE_CMD,
/* start system var section: VECHO */
VECHO,
VCOLMAX,
VTIMER,
VRTIMER,
TRACE,
VOICE,
VSHORTOUT,
VPRINTLEVEL,
/* end system var section: VPRINTLEVEL */
MAX_TOK /* must be the last, biggest token number */
};
UMINUS
@ UMINUS
Definition grammar.cc:352
ERROR_CMD
@ ERROR_CMD
Definition tok.h:72
PFAC_CMD
@ PFAC_CMD
Definition tok.h:154
PARSTR_CMD
@ PARSTR_CMD
Definition tok.h:153
HIGHCORNER_CMD
@ HIGHCORNER_CMD
Definition tok.h:88
ELIMINATION_CMD
@ ELIMINATION_CMD
Definition tok.h:69
NCALGEBRA_CMD
@ NCALGEBRA_CMD
Definition tok.h:138
REPART_CMD
@ REPART_CMD
Definition tok.h:168
VCOLMAX
@ VCOLMAX
Definition tok.h:211
ALIAS_CMD
@ ALIAS_CMD
Definition tok.h:34
SIMPLEX_CMD
@ SIMPLEX_CMD
Definition tok.h:179
VARIABLES_CMD
@ VARIABLES_CMD
Definition tok.h:201
JACOB_CMD
@ JACOB_CMD
Definition tok.h:103
MSTD_CMD
@ MSTD_CMD
Definition tok.h:133
INDEPSET_CMD
@ INDEPSET_CMD
Definition tok.h:94
BIGINT_CMD
@ BIGINT_CMD
Definition tok.h:38
SIMPLIFY_CMD
@ SIMPLIFY_CMD
Definition tok.h:180
CRING_CMD
@ CRING_CMD
Definition tok.h:56
LIST_CMD
@ LIST_CMD
Definition tok.h:118
FGLMQUOT_CMD
@ FGLMQUOT_CMD
Definition tok.h:84
RESTART_CMD
@ RESTART_CMD
Definition tok.h:172
VSHORTOUT
@ VSHORTOUT
Definition tok.h:216
BAREISS_CMD
@ BAREISS_CMD
Definition tok.h:37
DEG_CMD
@ DEG_CMD
Definition tok.h:60
VPRINTLEVEL
@ VPRINTLEVEL
Definition tok.h:217
LUS_CMD
@ LUS_CMD
Definition tok.h:123
READ_CMD
@ READ_CMD
Definition tok.h:165
CLOSE_CMD
@ CLOSE_CMD
Definition tok.h:49
SLIM_GB_CMD
@ SLIM_GB_CMD
Definition tok.h:181
INTVEC_CMD
@ INTVEC_CMD
Definition tok.h:101
RANDOM_CMD
@ RANDOM_CMD
Definition tok.h:163
COUNT_CMD
@ COUNT_CMD
Definition tok.h:55
FWALK_CMD
@ FWALK_CMD
Definition tok.h:82
MULTIPLICITY_CMD
@ MULTIPLICITY_CMD
Definition tok.h:134
NAMES_CMD
@ NAMES_CMD
Definition tok.h:136
PACKAGE_CMD
@ PACKAGE_CMD
Definition tok.h:150
BRANCHTO_CMD
@ BRANCHTO_CMD
Definition tok.h:39
END_GRAMMAR
@ END_GRAMMAR
Definition tok.h:70
MODULO_CMD
@ MODULO_CMD
Definition tok.h:128
JET_CMD
@ JET_CMD
Definition tok.h:105
CMATRIX_CMD
@ CMATRIX_CMD
Definition tok.h:46
HILBERT_CMD
@ HILBERT_CMD
Definition tok.h:89
DIFF_CMD
@ DIFF_CMD
Definition tok.h:65
RIGHTSTD_CMD
@ RIGHTSTD_CMD
Definition tok.h:174
VANDER_CMD
@ VANDER_CMD
Definition tok.h:200
HOMOG_CMD
@ HOMOG_CMD
Definition tok.h:90
NVARS_CMD
@ NVARS_CMD
Definition tok.h:143
MEMORY_CMD
@ MEMORY_CMD
Definition tok.h:124
NEWTONPOLY_CMD
@ NEWTONPOLY_CMD
Definition tok.h:140
DEF_CMD
@ DEF_CMD
Definition tok.h:58
KBASE_CMD
@ KBASE_CMD
Definition tok.h:106
VECHO
@ VECHO
Definition tok.h:210
ATTRIB_CMD
@ ATTRIB_CMD
Definition tok.h:36
LRES_CMD
@ LRES_CMD
Definition tok.h:120
IMPORTFROM_CMD
@ IMPORTFROM_CMD
Definition tok.h:93
SUBST_CMD
@ SUBST_CMD
Definition tok.h:188
CHARSTR_CMD
@ CHARSTR_CMD
Definition tok.h:43
HRES_CMD
@ HRES_CMD
Definition tok.h:91
JANET_CMD
@ JANET_CMD
Definition tok.h:104
REDUCE_CMD
@ REDUCE_CMD
Definition tok.h:166
LIFTSTD_CMD
@ LIFTSTD_CMD
Definition tok.h:115
KRES_CMD
@ KRES_CMD
Definition tok.h:109
MRES_MAP_CMD
@ MRES_MAP_CMD
Definition tok.h:132
BREAKPOINT_CMD
@ BREAKPOINT_CMD
Definition tok.h:41
OPTION_CMD
@ OPTION_CMD
Definition tok.h:148
OPEN_CMD
@ OPEN_CMD
Definition tok.h:145
COEFFS_CMD
@ COEFFS_CMD
Definition tok.h:50
LEADEXP_CMD
@ LEADEXP_CMD
Definition tok.h:113
QRDS_CMD
@ QRDS_CMD
Definition tok.h:161
CONTRACT_CMD
@ CONTRACT_CMD
Definition tok.h:54
CNUMBER_CMD
@ CNUMBER_CMD
Definition tok.h:47
LIFT_CMD
@ LIFT_CMD
Definition tok.h:116
TRANSPOSE_CMD
@ TRANSPOSE_CMD
Definition tok.h:193
LINK_CMD
@ LINK_CMD
Definition tok.h:117
BRACKET_CMD
@ BRACKET_CMD
Definition tok.h:40
STD_CMD
@ STD_CMD
Definition tok.h:186
SBA_CMD
@ SBA_CMD
Definition tok.h:178
WAITALL_CMD
@ WAITALL_CMD
Definition tok.h:205
EXECUTE_CMD
@ EXECUTE_CMD
Definition tok.h:73
TRACE
@ TRACE
Definition tok.h:214
DET_CMD
@ DET_CMD
Definition tok.h:64
DBPRINT_CMD
@ DBPRINT_CMD
Definition tok.h:57
CHINREM_CMD
@ CHINREM_CMD
Definition tok.h:45
RING_LIST_CMD
@ RING_LIST_CMD
Definition tok.h:176
NUMERATOR_CMD
@ NUMERATOR_CMD
Definition tok.h:142
NC_ALGEBRA_CMD
@ NC_ALGEBRA_CMD
Definition tok.h:139
URSOLVE_CMD
@ URSOLVE_CMD
Definition tok.h:199
ORD_CMD
@ ORD_CMD
Definition tok.h:144
QRING_CMD
@ QRING_CMD
Definition tok.h:160
PRINT_CMD
@ PRINT_CMD
Definition tok.h:156
FMD_CMD
@ FMD_CMD
Definition tok.h:80
UNIVARIATE_CMD
@ UNIVARIATE_CMD
Definition tok.h:197
PARDEG_CMD
@ PARDEG_CMD
Definition tok.h:151
MPRES_CMD
@ MPRES_CMD
Definition tok.h:130
NPARS_CMD
@ NPARS_CMD
Definition tok.h:141
PARENT_CMD
@ PARENT_CMD
Definition tok.h:152
MRES_CMD
@ MRES_CMD
Definition tok.h:131
DIVISION_CMD
@ DIVISION_CMD
Definition tok.h:67
PRIME_CMD
@ PRIME_CMD
Definition tok.h:155
LEADCOEF_CMD
@ LEADCOEF_CMD
Definition tok.h:112
EXPORTTO_CMD
@ EXPORTTO_CMD
Definition tok.h:74
IMPART_CMD
@ IMPART_CMD
Definition tok.h:92
NAMEOF_CMD
@ NAMEOF_CMD
Definition tok.h:135
PRUNE_MAP_CMD
@ PRUNE_MAP_CMD
Definition tok.h:158
TYPEOF_CMD
@ TYPEOF_CMD
Definition tok.h:196
KILLATTR_CMD
@ KILLATTR_CMD
Definition tok.h:108
REGULARITY_CMD
@ REGULARITY_CMD
Definition tok.h:167
WAIT1ST_CMD
@ WAIT1ST_CMD
Definition tok.h:204
CONTENT_CMD
@ CONTENT_CMD
Definition tok.h:53
STRING_CMD
@ STRING_CMD
Definition tok.h:187
WRITE_CMD
@ WRITE_CMD
Definition tok.h:208
DEGREE_CMD
@ DEGREE_CMD
Definition tok.h:61
OPPOSITE_CMD
@ OPPOSITE_CMD
Definition tok.h:147
GETDUMP_CMD
@ GETDUMP_CMD
Definition tok.h:87
SRES_CMD
@ SRES_CMD
Definition tok.h:184
WEIGHT_CMD
@ WEIGHT_CMD
Definition tok.h:207
ALIGN_CMD
@ ALIGN_CMD
Definition tok.h:35
MONITOR_CMD
@ MONITOR_CMD
Definition tok.h:129
VARSTR_CMD
@ VARSTR_CMD
Definition tok.h:202
PRUNE_CMD
@ PRUNE_CMD
Definition tok.h:157
STATUS_CMD
@ STATUS_CMD
Definition tok.h:185
DUMP_CMD
@ DUMP_CMD
Definition tok.h:68
RESERVEDNAMELIST_CMD
@ RESERVEDNAMELIST_CMD
Definition tok.h:171
FIND_CMD
@ FIND_CMD
Definition tok.h:78
ENVELOPE_CMD
@ ENVELOPE_CMD
Definition tok.h:71
COEF_CMD
@ COEF_CMD
Definition tok.h:51
INTERRED_CMD
@ INTERRED_CMD
Definition tok.h:99
WEDGE_CMD
@ WEDGE_CMD
Definition tok.h:206
SQR_FREE_CMD
@ SQR_FREE_CMD
Definition tok.h:183
DELETE_CMD
@ DELETE_CMD
Definition tok.h:62
SORTVEC_CMD
@ SORTVEC_CMD
Definition tok.h:182
FACSTD_CMD
@ FACSTD_CMD
Definition tok.h:79
MINOR_CMD
@ MINOR_CMD
Definition tok.h:126
VTIMER
@ VTIMER
Definition tok.h:212
QHWEIGHT_CMD
@ QHWEIGHT_CMD
Definition tok.h:159
VRTIMER
@ VRTIMER
Definition tok.h:213
RINGLIST_CMD
@ RINGLIST_CMD
Definition tok.h:175
LEAD_CMD
@ LEAD_CMD
Definition tok.h:111
ORDSTR_CMD
@ ORDSTR_CMD
Definition tok.h:149
LOAD_CMD
@ LOAD_CMD
Definition tok.h:119
DENOMINATOR_CMD
@ DENOMINATOR_CMD
Definition tok.h:63
TWOSTD_CMD
@ TWOSTD_CMD
Definition tok.h:195
FINDUNI_CMD
@ FINDUNI_CMD
Definition tok.h:85
VOICE
@ VOICE
Definition tok.h:215
CPOLY_CMD
@ CPOLY_CMD
Definition tok.h:48
INTDIV_CMD
@ INTDIV_CMD
Definition tok.h:97
TRACE_CMD
@ TRACE_CMD
Definition tok.h:194
INT_CMD
@ INT_CMD
Definition tok.h:96
QUOTIENT_CMD
@ QUOTIENT_CMD
Definition tok.h:162
INTERSECT_CMD
@ INTERSECT_CMD
Definition tok.h:100
KERNEL_CMD
@ KERNEL_CMD
Definition tok.h:107
INSERT_CMD
@ INSERT_CMD
Definition tok.h:95
LUI_CMD
@ LUI_CMD
Definition tok.h:122
EXTGCD_CMD
@ EXTGCD_CMD
Definition tok.h:75
VDIM_CMD
@ VDIM_CMD
Definition tok.h:203
TEST_CMD
@ TEST_CMD
Definition tok.h:192
GCD_CMD
@ GCD_CMD
Definition tok.h:86
SYSTEM_CMD
@ SYSTEM_CMD
Definition tok.h:189
MINBASE_CMD
@ MINBASE_CMD
Definition tok.h:125
SYZYGY_CMD
@ SYZYGY_CMD
Definition tok.h:190
FAREY_CMD
@ FAREY_CMD
Definition tok.h:77
INTERPOLATE_CMD
@ INTERPOLATE_CMD
Definition tok.h:98
LEADMONOM_CMD
@ LEADMONOM_CMD
Definition tok.h:114
DIM_CMD
@ DIM_CMD
Definition tok.h:66
NEWSTRUCT_CMD
@ NEWSTRUCT_CMD
Definition tok.h:137
ROWS_CMD
@ ROWS_CMD
Definition tok.h:177
RESERVEDNAME_CMD
@ RESERVEDNAME_CMD
Definition tok.h:170
RESULTANT_CMD
@ RESULTANT_CMD
Definition tok.h:173
OPPOSE_CMD
@ OPPOSE_CMD
Definition tok.h:146
TENSOR_CMD
@ TENSOR_CMD
Definition tok.h:191
DEFINED_CMD
@ DEFINED_CMD
Definition tok.h:59
MAX_TOK
@ MAX_TOK
Definition tok.h:220
FRES_CMD
@ FRES_CMD
Definition tok.h:81
IS_RINGVAR
@ IS_RINGVAR
Definition tok.h:102
CHARACTERISTIC_CMD
@ CHARACTERISTIC_CMD
Definition tok.h:42
LU_CMD
@ LU_CMD
Definition tok.h:121
COLS_CMD
@ COLS_CMD
Definition tok.h:52
FAC_CMD
@ FAC_CMD
Definition tok.h:76
MINRES_CMD
@ MINRES_CMD
Definition tok.h:127
LAGSOLVE_CMD
@ LAGSOLVE_CMD
Definition tok.h:110
CHAR_SERIES_CMD
@ CHAR_SERIES_CMD
Definition tok.h:44
FGLM_CMD
@ FGLM_CMD
Definition tok.h:83
UNLOAD_CMD
@ UNLOAD_CMD
Definition tok.h:198
RES_CMD
@ RES_CMD
Definition tok.h:169
RANK_CMD
@ RANK_CMD
Definition tok.h:164

## Function Documentation

## yyparse()

int yyparse | ( | void |  | ) |

extern

Definition at line 2149 of file grammar.cc.

{
/* The lookahead symbol. */
int yychar;
/* The semantic value of the lookahead symbol. */
YYSTYPE yylval;
/* Number of syntax errors so far. */
int yynerrs;
int yystate;
/* Number of tokens to shift before error messages enabled. */
int yyerrstatus;
/* The stacks and their tools:
`yyss': related to states.
`yyvs': related to semantic values.
Refer to the stacks thru separate pointers, to allow yyoverflow
to reallocate them elsewhere. */
/* The state stack. */
yytype_int16 yyssa[YYINITDEPTH];
yytype_int16 *yyss;
yytype_int16 *yyssp;
/* The semantic value stack. */
YYSTYPE yyvsa[YYINITDEPTH];
YYSTYPE *yyvs;
YYSTYPE *yyvsp;
YYSIZE_T yystacksize;
int yyn;
int yyresult;
/* Lookahead token as an internal (translated) token number. */
int yytoken;
/* The variables used to return semantic value and location from the
action routines. */
YYSTYPE yyval;
#if YYERROR_VERBOSE
/* Buffer for error messages, and its allocated size. */
char yymsgbuf[128];
char *yymsg = yymsgbuf;
YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif
#define YYPOPSTACK(N) (yyvsp -= (N), yyssp -= (N))
/* The number of symbols on the RHS of the reduced rule.
Keep to zero when no symbol should be popped. */
int yylen = 0;
yytoken = 0;
yyss = yyssa;
yyvs = yyvsa;
yystacksize = YYINITDEPTH;
YYDPRINTF ((stderr, "Starting parse\n"));
yystate = 0;
yyerrstatus = 0;
yynerrs = 0;
yychar = YYEMPTY; /* Cause a token to be read. */
/* Initialize stack pointers.
Waste one element of value and location stack
so that they stay on the same level as the state stack.
The wasted elements are never initialized. */
yyssp = yyss;
yyvsp = yyvs;
goto yysetstate;
/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate. |
`------------------------------------------------------------*/
yynewstate:
/* In all cases, when you get here, the value and location stacks
have just been pushed. So pushing a state here evens the stacks. */
yyssp++;
yysetstate:
*yyssp = yystate;
if (yyss + yystacksize - 1 <= yyssp)
{
/* Get the current used size of the three stacks, in elements. */
YYSIZE_T yysize = yyssp - yyss + 1;
#ifdef yyoverflow
{
/* Give user a chance to reallocate the stack. Use copies of
these so that the &'s don't force the real ones into
memory. */
YYSTYPE *yyvs1 = yyvs;
yytype_int16 *yyss1 = yyss;
/* Each stack pointer address is followed by the size of the
data in use in that stack, in bytes. This used to be a
conditional around just the two extra args, but that might
be undefined if yyoverflow is a macro. */
yyoverflow (YY_("memory exhausted"),
&yyss1, yysize * sizeof (*yyssp),
&yyvs1, yysize * sizeof (*yyvsp),
&yystacksize);
yyss = yyss1;
yyvs = yyvs1;
}
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
goto yyexhaustedlab;
# else
/* Extend the stack our own way. */
if (YYMAXDEPTH <= yystacksize)
goto yyexhaustedlab;
yystacksize *= 2;
if (YYMAXDEPTH < yystacksize)
yystacksize = YYMAXDEPTH;
{
yytype_int16 *yyss1 = yyss;
union yyalloc *yyptr =
(union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
if (! yyptr)
goto yyexhaustedlab;
YYSTACK_RELOCATE (yyss_alloc, yyss);
YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
if (yyss1 != yyssa)
YYSTACK_FREE (yyss1);
}
# endif
#endif /* no yyoverflow */
yyssp = yyss + yysize - 1;
yyvsp = yyvs + yysize - 1;
YYDPRINTF ((stderr, "Stack size increased to %lu\n",
(unsigned long int) yystacksize));
if (yyss + yystacksize - 1 <= yyssp)
YYABORT;
}
YYDPRINTF ((stderr, "Entering state %d\n", yystate));
if (yystate == YYFINAL)
YYACCEPT;
goto yybackup;
/*-----------.
| yybackup. |
`-----------*/
yybackup:
/* Do appropriate processing given the current state. Read a
lookahead token if we need one and don't already have one. */
/* First try to decide what to do without reference to lookahead token. */
yyn = yypact[yystate];
if (yyn == YYPACT_NINF)
goto yydefault;
/* Not known => get a lookahead token if don't already have one. */
/* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol. */
if (yychar == YYEMPTY)
{
YYDPRINTF ((stderr, "Reading a token: "));
yychar = YYLEX;
}
if (yychar <= YYEOF)
{
yychar = yytoken = YYEOF;
YYDPRINTF ((stderr, "Now at end of input.\n"));
}
else
{
yytoken = YYTRANSLATE (yychar);
YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
}
/* If the proper action on seeing token YYTOKEN is to reduce or to
detect an error, take that action. */
yyn += yytoken;
if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
goto yydefault;
yyn = yytable[yyn];
if (yyn <= 0)
{
if (yyn == 0 || yyn == YYTABLE_NINF)
goto yyerrlab;
yyn = -yyn;
goto yyreduce;
}
/* Count tokens shifted since error; after three, turn off error
status. */
if (yyerrstatus)
yyerrstatus--;
/* Shift the lookahead token. */
YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
/* Discard the shifted token. */
yychar = YYEMPTY;
yystate = yyn;
*++yyvsp = yylval;
goto yynewstate;
/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state. |
`-----------------------------------------------------------*/
yydefault:
yyn = yydefact[yystate];
if (yyn == 0)
goto yyerrlab;
goto yyreduce;
/*-----------------------------.
| yyreduce -- Do a reduction. |
`-----------------------------*/
yyreduce:
/* yyn is the number of a rule to reduce with. */
yylen = yyr2[yyn];
/* If YYLEN is nonzero, implement the default value of the action:
`$$ = $1'.
Otherwise, the following line sets YYVAL to garbage.
This behavior is undocumented and Bison
users should not rely upon it. Assigning to YYVAL
unconditionally makes the parser a bit smaller, and it avoids a
GCC warning that YYVAL may be used uninitialized. */
yyval = yyvsp[1-yylen];
YY_REDUCE_PRINT (yyn);
switch (yyn)
{
case 3:
/* Line 1464 of yacc.c */
#line 322 "grammar.y"
{
if (timerv)
{
writeTime("used time:");
startTimer();
}
if (rtimerv)
{
writeRTime("used real time:");
startRTimer();
}
prompt_char = '>';
#ifdef HAVE_SDB
if (sdb_flags & 2) { sdb_flags=1; YYERROR; }
#endif
if(siCntrlc)
{
WerrorS("abort...");
while((currentVoice!=NULL) && (currentVoice->prev!=NULL)) exitVoice();
if (currentVoice!=NULL) currentVoice->ifsw=0;
}
if (errorreported) /* also catches abort... */
{
yyerror("");
}
if (inerror==2) PrintLn();
errorreported = inerror = cmdtok = 0;
lastreserved = currid = NULL;
expected_parms = siCntrlc = FALSE;
;}
break;
case 5:
/* Line 1464 of yacc.c */
#line 357 "grammar.y"
{currentVoice->ifsw=0;;}
break;
case 6:
/* Line 1464 of yacc.c */
#line 359 "grammar.y"
{ (yyvsp[(1) - (2)].lv).CleanUp(); currentVoice->ifsw=0;;}
break;
case 7:
/* Line 1464 of yacc.c */
#line 361 "grammar.y"
{
YYACCEPT;
;}
break;
case 8:
/* Line 1464 of yacc.c */
#line 365 "grammar.y"
{
currentVoice->ifsw=0;
iiDebug();
;}
break;
case 9:
/* Line 1464 of yacc.c */
#line 370 "grammar.y"
{currentVoice->ifsw=0;;}
break;
case 10:
/* Line 1464 of yacc.c */
#line 372 "grammar.y"
{
#ifdef SIQ
siq=0;
#endif
yyInRingConstruction = FALSE;
currentVoice->ifsw=0;
if (inerror)
{
/* bison failed here*/
if ((inerror!=3) && ((yyvsp[(1) - (2)].i)<UMINUS) && ((yyvsp[(1) - (2)].i)>' '))
{
// 1: yyerror called
// 2: scanner put actual string
// 3: error rule put token+\n
inerror=3;
Print(" error at token `%s`\n",iiTwoOps((yyvsp[(1) - (2)].i)));
}
/**/
}
if (!errorreported) WerrorS("...parse error");
yyerror("");
yyerrok;
#ifdef HAVE_SDB
if ((sdb_flags & 1) && currentVoice->pi!=NULL)
{
currentVoice->pi->trace_flag |=1;
}
else
#endif
if (myynest>0)
{
feBufferTypes t=currentVoice->Typ();
//PrintS("leaving yyparse\n");
exitBuffer(BT_proc);
if (t==BT_example)
YYACCEPT;
else
YYABORT;
}
else if (currentVoice->prev!=NULL)
{
exitVoice();
}
#ifdef HAVE_SDB
if (sdb_flags &2) sdb_flags=1;
#endif
;}
break;
case 18:
/* Line 1464 of yacc.c */
#line 430 "grammar.y"
{if (currentVoice!=NULL) currentVoice->ifsw=0;;}
break;
case 19:
/* Line 1464 of yacc.c */
#line 433 "grammar.y"
{ omFree((ADDRESS)(yyvsp[(2) - (2)].name)); ;}
break;
case 29:
/* Line 1464 of yacc.c */
#line 448 "grammar.y"
{
if(iiAssign(&(yyvsp[(1) - (2)].lv),&(yyvsp[(2) - (2)].lv))) YYERROR;
;}
break;
case 30:
/* Line 1464 of yacc.c */
#line 455 "grammar.y"
{
if (currRing==NULL) MYYERROR("no ring active (7)");
syMakeMonom(&(yyval.lv),(yyvsp[(1) - (1)].name));
;}
break;
case 31:
/* Line 1464 of yacc.c */
#line 460 "grammar.y"
{
syMake(&(yyval.lv),(yyvsp[(1) - (1)].name));
;}
break;
case 32:
/* Line 1464 of yacc.c */
#line 464 "grammar.y"
{
if(iiExprArith2(&(yyval.lv), &(yyvsp[(1) - (3)].lv), COLONCOLON, &(yyvsp[(3) - (3)].lv))) YYERROR;
;}
break;
case 33:
/* Line 1464 of yacc.c */
#line 468 "grammar.y"
{
if(iiExprArith2(&(yyval.lv), &(yyvsp[(1) - (3)].lv), '.', &(yyvsp[(3) - (3)].lv))) YYERROR;
;}
break;
case 34:
/* Line 1464 of yacc.c */
#line 472 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(1) - (3)].lv),'(')) YYERROR;
;}
break;
case 35:
/* Line 1464 of yacc.c */
#line 476 "grammar.y"
{
if ((yyvsp[(1) - (4)].lv).next==NULL)
{
(yyvsp[(1) - (4)].lv).next=(leftv)omAllocBin(sleftv_bin);
memcpy((yyvsp[(1) - (4)].lv).next,&(yyvsp[(3) - (4)].lv),sizeof(sleftv));
if(iiExprArithM(&(yyval.lv),&(yyvsp[(1) - (4)].lv),'(')) YYERROR;
}
else if ((yyvsp[(1) - (4)].lv).rtyp==UNKNOWN)
{ // for x(i)(j)
if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (4)].lv),'(',&(yyvsp[(3) - (4)].lv))) YYERROR;
}
else YYERROR;
;}
break;
case 36:
/* Line 1464 of yacc.c */
#line 490 "grammar.y"
{
if (currRing==NULL) MYYERROR("no ring active (8)");
int j = 0;
memset(&(yyval.lv),0,sizeof(sleftv));
(yyval.lv).rtyp=VECTOR_CMD;
leftv v = &(yyvsp[(2) - (3)].lv);
while (v!=NULL)
{
int i,t;
sleftv tmp;
memset(&tmp,0,sizeof(tmp));
i=iiTestConvert((t=v->Typ()),POLY_CMD);
if((i==0) || (iiConvert(t /*v->Typ()*/,POLY_CMD,i,v,&tmp)))
{
pDelete((poly *)&(yyval.lv).data);
(yyvsp[(2) - (3)].lv).CleanUp();
MYYERROR("expected '[poly,...'");
}
poly p = (poly)tmp.CopyD(POLY_CMD);
pSetCompP(p,++j);
(yyval.lv).data = (void *)pAdd((poly)(yyval.lv).data,p);
v->next=tmp.next;tmp.next=NULL;
tmp.CleanUp();
v=v->next;
}
(yyvsp[(2) - (3)].lv).CleanUp();
;}
break;
case 37:
/* Line 1464 of yacc.c */
#line 518 "grammar.y"
{
memset(&(yyval.lv),0,sizeof((yyval.lv)));
int i = atoi((yyvsp[(1) - (1)].name));
/*remember not to omFree($1)
*because it is a part of the scanner buffer*/
(yyval.lv).rtyp = INT_CMD;
(yyval.lv).data = (void *)(long)i;
/* check: out of range input */
int l = strlen((yyvsp[(1) - (1)].name))+2;
number n;
if (l >= MAX_INT_LEN)
{
char tmp[MAX_INT_LEN+5];
snprintf(tmp,MAX_INT_LEN+5,"%d",i);
if (strcmp(tmp,(yyvsp[(1) - (1)].name))!=0)
{
n_Read((yyvsp[(1) - (1)].name),&n,coeffs_BIGINT);
(yyval.lv).rtyp=BIGINT_CMD;
(yyval.lv).data = n;
}
}
;}
break;
case 38:
/* Line 1464 of yacc.c */
#line 542 "grammar.y"
{
memset(&(yyval.lv),0,sizeof((yyval.lv)));
(yyval.lv).rtyp = (yyvsp[(1) - (1)].i);
(yyval.lv).data = (yyval.lv).Data();
;}
break;
case 39:
/* Line 1464 of yacc.c */
#line 548 "grammar.y"
{
memset(&(yyval.lv),0,sizeof((yyval.lv)));
(yyval.lv).rtyp = STRING_CMD;
(yyval.lv).data = (yyvsp[(1) - (1)].name);
;}
break;
case 40:
/* Line 1464 of yacc.c */
#line 554 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(3) - (4)].lv),(yyvsp[(1) - (4)].i))) YYERROR;
;}
break;
case 41:
/* Line 1464 of yacc.c */
#line 558 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(3) - (4)].lv),(yyvsp[(1) - (4)].i))) YYERROR;
;}
break;
case 42:
/* Line 1464 of yacc.c */
#line 562 "grammar.y"
{
if(iiExprArithM(&(yyval.lv),&(yyvsp[(3) - (4)].lv),(yyvsp[(1) - (4)].i))) YYERROR;
;}
break;
case 43:
/* Line 1464 of yacc.c */
#line 566 "grammar.y"
{
if(iiExprArithM(&(yyval.lv),NULL,(yyvsp[(1) - (3)].i))) YYERROR;
;}
break;
case 44:
/* Line 1464 of yacc.c */
#line 570 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(3) - (4)].lv),(yyvsp[(1) - (4)].i))) YYERROR;
;}
break;
case 45:
/* Line 1464 of yacc.c */
#line 574 "grammar.y"
{
if(iiExprArithM(&(yyval.lv),&(yyvsp[(3) - (4)].lv),(yyvsp[(1) - (4)].i))) YYERROR;
;}
break;
case 46:
/* Line 1464 of yacc.c */
#line 578 "grammar.y"
{
if(iiExprArithM(&(yyval.lv),NULL,(yyvsp[(1) - (3)].i))) YYERROR;
;}
break;
case 47:
/* Line 1464 of yacc.c */
#line 582 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(3) - (4)].lv),(yyvsp[(1) - (4)].i))) YYERROR;
;}
break;
case 48:
/* Line 1464 of yacc.c */
#line 586 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(3) - (4)].lv),(yyvsp[(1) - (4)].i))) YYERROR;
;}
break;
case 49:
/* Line 1464 of yacc.c */
#line 590 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(3) - (4)].lv),(yyvsp[(1) - (4)].i))) YYERROR;
;}
break;
case 50:
/* Line 1464 of yacc.c */
#line 594 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(3) - (4)].lv),(yyvsp[(1) - (4)].i))) YYERROR;
;}
break;
case 51:
/* Line 1464 of yacc.c */
#line 598 "grammar.y"
{
if(iiExprArith2(&(yyval.lv),&(yyvsp[(3) - (6)].lv),(yyvsp[(1) - (6)].i),&(yyvsp[(5) - (6)].lv),TRUE)) YYERROR;
;}
break;
case 52:
/* Line 1464 of yacc.c */
#line 602 "grammar.y"
{
if(iiExprArith2(&(yyval.lv),&(yyvsp[(3) - (6)].lv),(yyvsp[(1) - (6)].i),&(yyvsp[(5) - (6)].lv),TRUE)) YYERROR;
;}
break;
case 53:
/* Line 1464 of yacc.c */
#line 606 "grammar.y"
{
if(iiExprArith2(&(yyval.lv),&(yyvsp[(3) - (6)].lv),(yyvsp[(1) - (6)].i),&(yyvsp[(5) - (6)].lv),TRUE)) YYERROR;
;}
break;
case 54:
/* Line 1464 of yacc.c */
#line 610 "grammar.y"
{
if(iiExprArith2(&(yyval.lv),&(yyvsp[(3) - (6)].lv),(yyvsp[(1) - (6)].i),&(yyvsp[(5) - (6)].lv),TRUE)) YYERROR;
;}
break;
case 55:
/* Line 1464 of yacc.c */
#line 614 "grammar.y"
{
if(iiExprArith3(&(yyval.lv),(yyvsp[(1) - (8)].i),&(yyvsp[(3) - (8)].lv),&(yyvsp[(5) - (8)].lv),&(yyvsp[(7) - (8)].lv))) YYERROR;
;}
break;
case 56:
/* Line 1464 of yacc.c */
#line 618 "grammar.y"
{
if(iiExprArith3(&(yyval.lv),(yyvsp[(1) - (8)].i),&(yyvsp[(3) - (8)].lv),&(yyvsp[(5) - (8)].lv),&(yyvsp[(7) - (8)].lv))) YYERROR;
;}
break;
case 57:
/* Line 1464 of yacc.c */
#line 622 "grammar.y"
{
if(iiExprArith3(&(yyval.lv),(yyvsp[(1) - (8)].i),&(yyvsp[(3) - (8)].lv),&(yyvsp[(5) - (8)].lv),&(yyvsp[(7) - (8)].lv))) YYERROR;
;}
break;
case 58:
/* Line 1464 of yacc.c */
#line 626 "grammar.y"
{
if(iiExprArith3(&(yyval.lv),(yyvsp[(1) - (8)].i),&(yyvsp[(3) - (8)].lv),&(yyvsp[(5) - (8)].lv),&(yyvsp[(7) - (8)].lv))) YYERROR;
;}
break;
case 59:
/* Line 1464 of yacc.c */
#line 630 "grammar.y"
{
if(iiExprArithM(&(yyval.lv),NULL,(yyvsp[(1) - (3)].i))) YYERROR;
;}
break;
case 60:
/* Line 1464 of yacc.c */
#line 634 "grammar.y"
{
int b=iiExprArithM(&(yyval.lv),&(yyvsp[(3) - (4)].lv),(yyvsp[(1) - (4)].i)); // handle branchTo
if (b==TRUE) YYERROR;
if (b==2) YYACCEPT;
;}
break;
case 61:
/* Line 1464 of yacc.c */
#line 640 "grammar.y"
{
if(iiExprArith3(&(yyval.lv),(yyvsp[(1) - (8)].i),&(yyvsp[(3) - (8)].lv),&(yyvsp[(5) - (8)].lv),&(yyvsp[(7) - (8)].lv))) YYERROR;
;}
break;
case 62:
/* Line 1464 of yacc.c */
#line 644 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(3) - (4)].lv),(yyvsp[(1) - (4)].i))) YYERROR;
;}
break;
case 63:
/* Line 1464 of yacc.c */
#line 648 "grammar.y"
{
if(iiExprArith3(&(yyval.lv),RING_CMD,&(yyvsp[(3) - (8)].lv),&(yyvsp[(5) - (8)].lv),&(yyvsp[(7) - (8)].lv))) YYERROR;
;}
break;
case 64:
/* Line 1464 of yacc.c */
#line 652 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(3) - (4)].lv),RING_CMD)) YYERROR;
;}
break;
case 65:
/* Line 1464 of yacc.c */
#line 656 "grammar.y"
{
if (iiARROW(&(yyval.lv),(yyvsp[(1) - (3)].name),(yyvsp[(3) - (3)].name))) YYERROR;
omFree((ADDRESS)(yyvsp[(3) - (3)].name));
;}
break;
case 66:
/* Line 1464 of yacc.c */
#line 660 "grammar.y"
{ (yyval.lv) = (yyvsp[(2) - (3)].lv); ;}
break;
case 67:
/* Line 1464 of yacc.c */
#line 665 "grammar.y"
{
leftv v = &(yyvsp[(1) - (3)].lv);
while (v->next!=NULL)
{
v=v->next;
}
v->next = (leftv)omAllocBin(sleftv_bin);
memcpy(v->next,&((yyvsp[(3) - (3)].lv)),sizeof(sleftv));
(yyval.lv) = (yyvsp[(1) - (3)].lv);
;}
break;
case 71:
/* Line 1464 of yacc.c */
#line 681 "grammar.y"
{
if(iiExprArith3(&(yyval.lv),'[',&(yyvsp[(1) - (6)].lv),&(yyvsp[(3) - (6)].lv),&(yyvsp[(5) - (6)].lv))) YYERROR;
;}
break;
case 72:
/* Line 1464 of yacc.c */
#line 685 "grammar.y"
{
if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (4)].lv),'[',&(yyvsp[(3) - (4)].lv))) YYERROR;
;}
break;
case 73:
/* Line 1464 of yacc.c */
#line 689 "grammar.y"
{
if (iiApply(&(yyval.lv), &(yyvsp[(3) - (6)].lv), (yyvsp[(5) - (6)].i), NULL)) YYERROR;
;}
break;
case 74:
/* Line 1464 of yacc.c */
#line 693 "grammar.y"
{
if (iiApply(&(yyval.lv), &(yyvsp[(3) - (6)].lv), (yyvsp[(5) - (6)].i), NULL)) YYERROR;
;}
break;
case 75:
/* Line 1464 of yacc.c */
#line 697 "grammar.y"
{
if (iiApply(&(yyval.lv), &(yyvsp[(3) - (6)].lv), (yyvsp[(5) - (6)].i), NULL)) YYERROR;
;}
break;
case 76:
/* Line 1464 of yacc.c */
#line 701 "grammar.y"
{
if (iiApply(&(yyval.lv), &(yyvsp[(3) - (6)].lv), (yyvsp[(5) - (6)].i), NULL)) YYERROR;
;}
break;
case 77:
/* Line 1464 of yacc.c */
#line 705 "grammar.y"
{
if (iiApply(&(yyval.lv), &(yyvsp[(3) - (6)].lv), (yyvsp[(5) - (6)].i), NULL)) YYERROR;
;}
break;
case 78:
/* Line 1464 of yacc.c */
#line 709 "grammar.y"
{
if (iiApply(&(yyval.lv), &(yyvsp[(3) - (6)].lv), 0, &(yyvsp[(5) - (6)].lv))) YYERROR;
;}
break;
case 79:
/* Line 1464 of yacc.c */
#line 713 "grammar.y"
{
(yyval.lv)=(yyvsp[(2) - (3)].lv);
;}
break;
case 80:
/* Line 1464 of yacc.c */
#line 717 "grammar.y"
{
#ifdef SIQ
siq++;
if (siq>0)
{ if (iiExprArith2(&(yyval.lv),&(yyvsp[(2) - (5)].lv),'=',&(yyvsp[(4) - (5)].lv))) YYERROR; }
else
#endif
{
memset(&(yyval.lv),0,sizeof((yyval.lv)));
(yyval.lv).rtyp=NONE;
if (iiAssign(&(yyvsp[(2) - (5)].lv),&(yyvsp[(4) - (5)].lv))) YYERROR;
}
#ifdef SIQ
siq--;
#endif
;}
break;
case 81:
/* Line 1464 of yacc.c */
#line 734 "grammar.y"
{
iiTestAssume(&(yyvsp[(2) - (5)].lv),&(yyvsp[(4) - (5)].lv));
memset(&(yyval.lv),0,sizeof((yyval.lv)));
(yyval.lv).rtyp=NONE;
;}
break;
case 82:
/* Line 1464 of yacc.c */
#line 740 "grammar.y"
{
#ifdef SIQ
siq--;
#endif
;}
break;
case 83:
/* Line 1464 of yacc.c */
#line 746 "grammar.y"
{
#ifdef SIQ
if (siq<=0) (yyvsp[(4) - (5)].lv).Eval();
#endif
(yyval.lv)=(yyvsp[(4) - (5)].lv);
#ifdef SIQ
siq++;
#endif
;}
break;
case 84:
/* Line 1464 of yacc.c */
#line 758 "grammar.y"
{
#ifdef SIQ
siq++;
#endif
;}
break;
case 85:
/* Line 1464 of yacc.c */
#line 766 "grammar.y"
{
#ifdef SIQ
siq++;
#endif
;}
break;
case 86:
/* Line 1464 of yacc.c */
#line 774 "grammar.y"
{
#ifdef SIQ
siq--;
#endif
;}
break;
case 87:
/* Line 1464 of yacc.c */
#line 783 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(1) - (2)].lv),PLUSPLUS)) YYERROR;
;}
break;
case 88:
/* Line 1464 of yacc.c */
#line 787 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(1) - (2)].lv),MINUSMINUS)) YYERROR;
;}
break;
case 89:
/* Line 1464 of yacc.c */
#line 791 "grammar.y"
{
if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),'+',&(yyvsp[(3) - (3)].lv))) YYERROR;
;}
break;
case 90:
/* Line 1464 of yacc.c */
#line 795 "grammar.y"
{
if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),'-',&(yyvsp[(3) - (3)].lv))) YYERROR;
;}
break;
case 91:
/* Line 1464 of yacc.c */
#line 799 "grammar.y"
{ /* also for *,% */
if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),(yyvsp[(2) - (3)].i),&(yyvsp[(3) - (3)].lv))) YYERROR;
;}
break;
case 92:
/* Line 1464 of yacc.c */
#line 803 "grammar.y"
{
if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),'^',&(yyvsp[(3) - (3)].lv))) YYERROR;
;}
break;
case 93:
/* Line 1464 of yacc.c */
#line 807 "grammar.y"
{ /* also for > */
if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),(yyvsp[(2) - (3)].i),&(yyvsp[(3) - (3)].lv))) YYERROR;
;}
break;
case 94:
/* Line 1464 of yacc.c */
#line 811 "grammar.y"
{ /* also for |*/
if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),(yyvsp[(2) - (3)].i),&(yyvsp[(3) - (3)].lv))) YYERROR;
;}
break;
case 95:
/* Line 1464 of yacc.c */
#line 815 "grammar.y"
{
if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),NOTEQUAL,&(yyvsp[(3) - (3)].lv))) YYERROR;
;}
break;
case 96:
/* Line 1464 of yacc.c */
#line 819 "grammar.y"
{
if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),EQUAL_EQUAL,&(yyvsp[(3) - (3)].lv))) YYERROR;
;}
break;
case 97:
/* Line 1464 of yacc.c */
#line 823 "grammar.y"
{
if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),DOTDOT,&(yyvsp[(3) - (3)].lv))) YYERROR;
;}
break;
case 98:
/* Line 1464 of yacc.c */
#line 827 "grammar.y"
{
if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),':',&(yyvsp[(3) - (3)].lv))) YYERROR;
;}
break;
case 99:
/* Line 1464 of yacc.c */
#line 831 "grammar.y"
{
if (siq>0)
{ if (iiExprArith1(&(yyval.lv),&(yyvsp[(2) - (2)].lv),NOT)) YYERROR; }
else
{
memset(&(yyval.lv),0,sizeof((yyval.lv)));
int i; TESTSETINT((yyvsp[(2) - (2)].lv),i);
(yyval.lv).rtyp = INT_CMD;
(yyval.lv).data = (void *)(long)(i == 0 ? 1 : 0);
}
;}
break;
case 100:
/* Line 1464 of yacc.c */
#line 843 "grammar.y"
{
if(iiExprArith1(&(yyval.lv),&(yyvsp[(2) - (2)].lv),'-')) YYERROR;
;}
break;
case 102:
/* Line 1464 of yacc.c */
#line 851 "grammar.y"
{
if ((yyvsp[(1) - (2)].lv).rtyp==0)
{
Werror("`%s` is undefined",(yyvsp[(1) - (2)].lv).Fullname());
YYERROR;
}
else if (((yyvsp[(1) - (2)].lv).rtyp==MODUL_CMD)
// matrix m; m[2]=...
&& ((yyvsp[(1) - (2)].lv).e!=NULL) && ((yyvsp[(1) - (2)].lv).e->next==NULL))
{
MYYERROR("matrix must have 2 indices");
}
(yyval.lv) = (yyvsp[(1) - (2)].lv);
;}
break;
case 104:
/* Line 1464 of yacc.c */
#line 871 "grammar.y"
{
if ((yyvsp[(2) - (3)].lv).Typ()!=STRING_CMD)
{
MYYERROR("string expression expected");
}
(yyval.name) = (char *)(yyvsp[(2) - (3)].lv).CopyD(STRING_CMD);
(yyvsp[(2) - (3)].lv).CleanUp();
;}
break;
case 105:
/* Line 1464 of yacc.c */
#line 883 "grammar.y"
{
if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&((yyvsp[(2) - (2)].lv).req_packhdl->idroot)))
YYERROR;
;}
break;
case 106:
/* Line 1464 of yacc.c */
#line 888 "grammar.y"
{
if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&((yyvsp[(2) - (2)].lv).req_packhdl->idroot)))
YYERROR;
;}
break;
case 107:
/* Line 1464 of yacc.c */
#line 893 "grammar.y"
{
if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&(currRing->idroot), TRUE)) YYERROR;
;}
break;
case 108:
/* Line 1464 of yacc.c */
#line 897 "grammar.y"
{
if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&(currRing->idroot), TRUE)) YYERROR;
;}
break;
case 109:
/* Line 1464 of yacc.c */
#line 901 "grammar.y"
{
int r; TESTSETINT((yyvsp[(4) - (8)].lv),r);
int c; TESTSETINT((yyvsp[(7) - (8)].lv),c);
leftv v;
idhdl h;
if (((yyvsp[(1) - (8)].i) == MATRIX_CMD) || ((yyvsp[(1) - (8)].i) == SMATRIX_CMD ))
{
if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (8)].lv),myynest,(yyvsp[(1) - (8)].i),&(currRing->idroot), TRUE)) YYERROR;
v=&(yyval.lv);
h=(idhdl)v->data;
idDelete(&IDIDEAL(h));
if ((yyvsp[(1) - (8)].i) == MATRIX_CMD)
IDMATRIX(h) = mpNew(r,c);
else
IDIDEAL(h) = idInit(c,r);
if (IDMATRIX(h)==NULL) YYERROR;
}
else if (((yyvsp[(1) - (8)].i) == INTMAT_CMD)||((yyvsp[(1) - (8)].i) == BIGINTMAT_CMD))
{
if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (8)].lv),myynest,(yyvsp[(1) - (8)].i),&((yyvsp[(2) - (8)].lv).req_packhdl->idroot)))
YYERROR;
v=&(yyval.lv);
h=(idhdl)v->data;
if ((yyvsp[(1) - (8)].i)==INTMAT_CMD)
{
delete IDINTVEC(h);
IDINTVEC(h) = new intvec(r,c,0);
}
else
{
delete IDBIMAT(h);
IDBIMAT(h) = new bigintmat(r, c, coeffs_BIGINT);
}
if (IDINTVEC(h)==NULL) YYERROR;
}
;}
break;
case 110:
/* Line 1464 of yacc.c */
#line 938 "grammar.y"
{
if (((yyvsp[(1) - (2)].i) == MATRIX_CMD)||((yyvsp[(1) - (2)].i) == SMATRIX_CMD))
{
if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&(currRing->idroot), TRUE)) YYERROR;
}
else if (((yyvsp[(1) - (2)].i) == INTMAT_CMD)||((yyvsp[(1) - (2)].i) == BIGINTMAT_CMD))
{
if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&((yyvsp[(2) - (2)].lv).req_packhdl->idroot)))
YYERROR;
if ((yyvsp[(1) - (2)].i) == INTMAT_CMD)
{
leftv v=&(yyval.lv);
idhdl h;
do
{
h=(idhdl)v->data;
delete IDINTVEC(h);
IDINTVEC(h) = new intvec(1,1,0);
v=v->next;
} while (v!=NULL);
}
}
;}
break;
case 111:
/* Line 1464 of yacc.c */
#line 962 "grammar.y"
{
int t=(yyvsp[(1) - (3)].lv).Typ();
sleftv r;
memset(&r,0,sizeof(sleftv));
if ((BEGIN_RING<t) && (t<END_RING))
{
if (iiDeclCommand(&r,&(yyvsp[(3) - (3)].lv),myynest,t,&(currRing->idroot), TRUE))
YYERROR;
}
else
{
if (iiDeclCommand(&r,&(yyvsp[(3) - (3)].lv),myynest,t,&((yyvsp[(3) - (3)].lv).req_packhdl->idroot)))
YYERROR;
}
leftv v=&(yyvsp[(1) - (3)].lv);
while (v->next!=NULL) v=v->next;
v->next=(leftv)omAllocBin(sleftv_bin);
memcpy(v->next,&r,sizeof(sleftv));
(yyval.lv)=(yyvsp[(1) - (3)].lv);
;}
break;
case 112:
/* Line 1464 of yacc.c */
#line 983 "grammar.y"
{
if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&((yyvsp[(2) - (2)].lv).req_packhdl->idroot)))
YYERROR;
;}
break;
case 115:
/* Line 1464 of yacc.c */
#line 996 "grammar.y"
{
leftv v = &(yyvsp[(2) - (5)].lv);
while (v->next!=NULL)
{
v=v->next;
}
v->next = (leftv)omAllocBin(sleftv_bin);
memcpy(v->next,&((yyvsp[(4) - (5)].lv)),sizeof(sleftv));
(yyval.lv) = (yyvsp[(2) - (5)].lv);
;}
break;
case 116:
/* Line 1464 of yacc.c */
#line 1010 "grammar.y"
{
// let rInit take care of any errors
(yyval.i)=rOrderName((yyvsp[(1) - (1)].name));
;}
break;
case 117:
/* Line 1464 of yacc.c */
#line 1018 "grammar.y"
{
memset(&(yyval.lv),0,sizeof((yyval.lv)));
intvec *iv = new intvec(2);
(*iv)[0] = 1;
(*iv)[1] = (yyvsp[(1) - (1)].i);
(yyval.lv).rtyp = INTVEC_CMD;
(yyval.lv).data = (void *)iv;
;}
break;
case 118:
/* Line 1464 of yacc.c */
#line 1027 "grammar.y"
{
memset(&(yyval.lv),0,sizeof((yyval.lv)));
leftv sl = &(yyvsp[(3) - (4)].lv);
int slLength;
{
slLength = exprlist_length(sl);
int l = 2 + slLength;
intvec *iv = new intvec(l);
(*iv)[0] = slLength;
(*iv)[1] = (yyvsp[(1) - (4)].i);
int i = 2;
while ((i<l) && (sl!=NULL))
{
if (sl->Typ() == INT_CMD)
{
(*iv)[i++] = (int)((long)(sl->Data()));
}
else if ((sl->Typ() == INTVEC_CMD)
||(sl->Typ() == INTMAT_CMD))
{
intvec *ivv = (intvec *)(sl->Data());
int ll = 0,l = ivv->length();
for (; l>0; l--)
{
(*iv)[i++] = (*ivv)[ll++];
}
}
else
{
delete iv;
(yyvsp[(3) - (4)].lv).CleanUp();
MYYERROR("wrong type in ordering");
}
sl = sl->next;
}
(yyval.lv).rtyp = INTVEC_CMD;
(yyval.lv).data = (void *)iv;
}
(yyvsp[(3) - (4)].lv).CleanUp();
;}
break;
case 120:
/* Line 1464 of yacc.c */
#line 1073 "grammar.y"
{
(yyval.lv) = (yyvsp[(1) - (3)].lv);
(yyval.lv).next = (sleftv *)omAllocBin(sleftv_bin);
memcpy((yyval.lv).next,&(yyvsp[(3) - (3)].lv),sizeof(sleftv));
;}
break;
case 122:
/* Line 1464 of yacc.c */
#line 1083 "grammar.y"
{
(yyval.lv) = (yyvsp[(2) - (3)].lv);
;}
break;
case 123:
/* Line 1464 of yacc.c */
#line 1089 "grammar.y"
{
expected_parms = TRUE;
;}
break;
case 128:
/* Line 1464 of yacc.c */
#line 1107 "grammar.y"
{ newFile((yyvsp[(2) - (2)].name)); omFree((yyvsp[(2) - (2)].name)); ;}
break;
case 129:
/* Line 1464 of yacc.c */
#line 1112 "grammar.y"
{
feHelp((yyvsp[(2) - (3)].name));
omFree((ADDRESS)(yyvsp[(2) - (3)].name));
;}
break;
case 130:
/* Line 1464 of yacc.c */
#line 1117 "grammar.y"
{
feHelp(NULL);
;}
break;
case 131:
/* Line 1464 of yacc.c */
#line 1124 "grammar.y"
{
singular_example((yyvsp[(2) - (3)].name));
omFree((ADDRESS)(yyvsp[(2) - (3)].name));
;}
break;
case 132:
/* Line 1464 of yacc.c */
#line 1132 "grammar.y"
{
if (basePack!=(yyvsp[(2) - (2)].lv).req_packhdl)
{
if(iiExport(&(yyvsp[(2) - (2)].lv),0,currPack)) YYERROR;
}
else
if (iiExport(&(yyvsp[(2) - (2)].lv),0)) YYERROR;
;}
break;
case 133:
/* Line 1464 of yacc.c */
#line 1144 "grammar.y"
{
leftv v=&(yyvsp[(2) - (2)].lv);
if (v->rtyp!=IDHDL)
{
if (v->name!=NULL)
{
Werror("`%s` is undefined in kill",v->name);
omFree((ADDRESS)v->name); v->name=NULL;
}
else WerrorS("kill what ?");
}
else
{
killhdl((idhdl)v->data,v->req_packhdl);
}
;}
break;
case 134:
/* Line 1464 of yacc.c */
#line 1161 "grammar.y"
{
leftv v=&(yyvsp[(3) - (3)].lv);
if (v->rtyp!=IDHDL)
{
if (v->name!=NULL)
{
Werror("`%s` is undefined in kill",v->name);
omFree((ADDRESS)v->name); v->name=NULL;
}
else WerrorS("kill what ?");
}
else
{
killhdl((idhdl)v->data,v->req_packhdl);
}
;}
break;
case 135:
/* Line 1464 of yacc.c */
#line 1181 "grammar.y"
{
list_cmd((yyvsp[(3) - (4)].i),NULL,"// ",TRUE);
;}
break;
case 136:
/* Line 1464 of yacc.c */
#line 1185 "grammar.y"
{
list_cmd((yyvsp[(3) - (4)].i),NULL,"// ",TRUE);
;}
break;
case 137:
/* Line 1464 of yacc.c */
#line 1189 "grammar.y"
{
if ((yyvsp[(3) - (4)].i)==QRING_CMD) (yyvsp[(3) - (4)].i)=RING_CMD;
list_cmd((yyvsp[(3) - (4)].i),NULL,"// ",TRUE);
;}
break;
case 138:
/* Line 1464 of yacc.c */
#line 1194 "grammar.y"
{
list_cmd((yyvsp[(3) - (4)].i),NULL,"// ",TRUE);
;}
break;
case 139:
/* Line 1464 of yacc.c */
#line 1198 "grammar.y"
{
list_cmd(RING_CMD,NULL,"// ",TRUE);
;}
break;
case 140:
/* Line 1464 of yacc.c */
#line 1202 "grammar.y"
{
list_cmd((yyvsp[(3) - (4)].i),NULL,"// ",TRUE);
;}
break;
case 141:
/* Line 1464 of yacc.c */
#line 1206 "grammar.y"
{
list_cmd(PROC_CMD,NULL,"// ",TRUE);
;}
break;
case 142:
/* Line 1464 of yacc.c */
#line 1210 "grammar.y"
{
list_cmd(0,(yyvsp[(3) - (4)].lv).Fullname(),"// ",TRUE);
(yyvsp[(3) - (4)].lv).CleanUp();
;}
break;
case 143:
/* Line 1464 of yacc.c */
#line 1215 "grammar.y"
{
if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
list_cmd((yyvsp[(5) - (6)].i),NULL,"// ",TRUE);
(yyvsp[(3) - (6)].lv).CleanUp();
;}
break;
case 144:
/* Line 1464 of yacc.c */
#line 1221 "grammar.y"
{
if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
list_cmd((yyvsp[(5) - (6)].i),NULL,"// ",TRUE);
(yyvsp[(3) - (6)].lv).CleanUp();
;}
break;
case 145:
/* Line 1464 of yacc.c */
#line 1227 "grammar.y"
{
if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
list_cmd((yyvsp[(5) - (6)].i),NULL,"// ",TRUE);
(yyvsp[(3) - (6)].lv).CleanUp();
;}
break;
case 146:
/* Line 1464 of yacc.c */
#line 1233 "grammar.y"
{
if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
list_cmd((yyvsp[(5) - (6)].i),NULL,"// ",TRUE);
(yyvsp[(3) - (6)].lv).CleanUp();
;}
break;
case 147:
/* Line 1464 of yacc.c */
#line 1239 "grammar.y"
{
if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
list_cmd((yyvsp[(5) - (6)].i),NULL,"// ",TRUE);
(yyvsp[(3) - (6)].lv).CleanUp();
;}
break;
case 148:
/* Line 1464 of yacc.c */
#line 1245 "grammar.y"
{
if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
list_cmd((yyvsp[(5) - (6)].i),NULL,"// ",TRUE);
(yyvsp[(3) - (6)].lv).CleanUp();
;}
break;
case 149:
/* Line 1464 of yacc.c */
#line 1251 "grammar.y"
{
if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
list_cmd((yyvsp[(5) - (6)].i),NULL,"// ",TRUE);
(yyvsp[(3) - (6)].lv).CleanUp();
;}
break;
case 150:
/* Line 1464 of yacc.c */
#line 1263 "grammar.y"
{
list_cmd(-1,NULL,"// ",TRUE);
;}
break;
case 151:
/* Line 1464 of yacc.c */
#line 1269 "grammar.y"
{ yyInRingConstruction = TRUE; ;}
break;
case 152:
/* Line 1464 of yacc.c */
#line 1278 "grammar.y"
{
const char *ring_name = (yyvsp[(2) - (8)].lv).name;
ring b=
rInit(&(yyvsp[(4) - (8)].lv), /* characteristik and list of parameters*/
&(yyvsp[(6) - (8)].lv), /* names of ringvariables */
&(yyvsp[(8) - (8)].lv)); /* ordering */
idhdl newRingHdl=NULL;
if (b!=NULL)
{
newRingHdl=enterid(ring_name, myynest, RING_CMD,
&((yyvsp[(2) - (8)].lv).req_packhdl->idroot),FALSE);
(yyvsp[(2) - (8)].lv).CleanUp();
if (newRingHdl!=NULL)
{
IDRING(newRingHdl)=b;
}
else
{
rKill(b);
}
}
yyInRingConstruction = FALSE;
if (newRingHdl==NULL)
{
MYYERROR("cannot make ring");
}
else
{
rSetHdl(newRingHdl);
}
;}
break;
case 153:
/* Line 1464 of yacc.c */
#line 1311 "grammar.y"
{
const char *ring_name = (yyvsp[(2) - (2)].lv).name;
if (!inerror) rDefault(ring_name);
yyInRingConstruction = FALSE;
(yyvsp[(2) - (2)].lv).CleanUp();
;}
break;
case 154:
/* Line 1464 of yacc.c */
#line 1318 "grammar.y"
{
yyInRingConstruction = FALSE;
if (iiAssignCR(&(yyvsp[(2) - (4)].lv),&(yyvsp[(4) - (4)].lv))) YYERROR;
;}
break;
case 155:
/* Line 1464 of yacc.c */
#line 1323 "grammar.y"
{
yyInRingConstruction = FALSE;
sleftv tmp;
(yyvsp[(4) - (7)].lv).next=(leftv)omAlloc(sizeof(sleftv));
memcpy((yyvsp[(4) - (7)].lv).next,&(yyvsp[(6) - (7)].lv),sizeof(sleftv));
memset(&(yyvsp[(6) - (7)].lv),0,sizeof(sleftv));
if (iiExprArithM(&tmp,&(yyvsp[(4) - (7)].lv),'[')) YYERROR;
if (iiAssignCR(&(yyvsp[(2) - (7)].lv),&tmp)) YYERROR;
;}
break;
case 156:
/* Line 1464 of yacc.c */
#line 1336 "grammar.y"
{
if (((yyvsp[(1) - (2)].i)!=LIB_CMD)||(jjLOAD((yyvsp[(2) - (2)].name),TRUE))) YYERROR;
omFree((yyvsp[(2) - (2)].name));
;}
break;
case 159:
/* Line 1464 of yacc.c */
#line 1346 "grammar.y"
{
if (((yyvsp[(1) - (2)].i)==KEEPRING_CMD) && (myynest==0))
MYYERROR("only inside a proc allowed");
const char * n=(yyvsp[(2) - (2)].lv).Name();
if (((yyvsp[(2) - (2)].lv).Typ()==RING_CMD)
&& ((yyvsp[(2) - (2)].lv).rtyp==IDHDL))
{
idhdl h=(idhdl)(yyvsp[(2) - (2)].lv).data;
if ((yyvsp[(2) - (2)].lv).e!=NULL) h=rFindHdl((ring)(yyvsp[(2) - (2)].lv).Data(),NULL);
//Print("setring %s lev %d (ptr:%x)\n",IDID(h),IDLEV(h),IDRING(h));
if ((yyvsp[(1) - (2)].i)==KEEPRING_CMD)
{
if (h!=NULL)
{
if (IDLEV(h)!=0)
{
if (iiExport(&(yyvsp[(2) - (2)].lv),myynest-1)) YYERROR;
#if 1
idhdl p=IDRING(h)->idroot;
idhdl root=p;
int prevlev=myynest-1;
while (p!=NULL)
{
if (IDLEV(p)==myynest)
{
idhdl old=root->get(IDID(p),prevlev);
if (old!=NULL)
{
if (BVERBOSE(V_REDEFINE))
Warn("redefining %s",IDID(p));
killhdl2(old,&root,IDRING(h));
IDRING(h)->idroot=root;
}
IDLEV(p)=prevlev;
}
p=IDNEXT(p);
}
#endif
}
iiLocalRing[myynest-1]=IDRING(h);
}
else
{
Werror("%s is no identifier",n);
(yyvsp[(2) - (2)].lv).CleanUp();
YYERROR;
}
}
if (h!=NULL) rSetHdl(h);
else
{
Werror("cannot find the name of the basering %s",n);
(yyvsp[(2) - (2)].lv).CleanUp();
YYERROR;
}
(yyvsp[(2) - (2)].lv).CleanUp();
}
else
{
Werror("%s is no name of a ring/qring",n);
(yyvsp[(2) - (2)].lv).CleanUp();
YYERROR;
}
;}
break;
case 160:
/* Line 1464 of yacc.c */
#line 1414 "grammar.y"
{
type_cmd(&((yyvsp[(2) - (2)].lv)));
;}
break;
case 161:
/* Line 1464 of yacc.c */
#line 1418 "grammar.y"
{
//Print("typ is %d, rtyp:%d\n",$1.Typ(),$1.rtyp);
#ifdef SIQ
if ((yyvsp[(1) - (1)].lv).rtyp!=COMMAND)
{
#endif
if ((yyvsp[(1) - (1)].lv).Typ()==UNKNOWN)
{
if ((yyvsp[(1) - (1)].lv).name!=NULL)
{
Werror("`%s` is undefined",(yyvsp[(1) - (1)].lv).name);
omFree((ADDRESS)(yyvsp[(1) - (1)].lv).name);
}
YYERROR;
}
#ifdef SIQ
}
#endif
(yyvsp[(1) - (1)].lv).Print(&sLastPrinted);
(yyvsp[(1) - (1)].lv).CleanUp(currRing);
if (errorreported) YYERROR;
;}
break;
case 162:
/* Line 1464 of yacc.c */
#line 1447 "grammar.y"
{
int i; TESTSETINT((yyvsp[(3) - (5)].lv),i);
if (i!=0)
{
newBuffer( (yyvsp[(5) - (5)].name), BT_if);
}
else
{
omFree((ADDRESS)(yyvsp[(5) - (5)].name));
currentVoice->ifsw=1;
}
;}
break;
case 163:
/* Line 1464 of yacc.c */
#line 1460 "grammar.y"
{
if (currentVoice->ifsw==1)
{
currentVoice->ifsw=0;
newBuffer( (yyvsp[(2) - (2)].name), BT_else);
}
else
{
if (currentVoice->ifsw!=2)
{
Warn("`else` without `if` in level %d",myynest);
}
omFree((ADDRESS)(yyvsp[(2) - (2)].name));
}
currentVoice->ifsw=0;
;}
break;
case 164:
/* Line 1464 of yacc.c */
#line 1477 "grammar.y"
{
int i; TESTSETINT((yyvsp[(3) - (5)].lv),i);
if (i)
{
if (exitBuffer(BT_break)) YYERROR;
}
currentVoice->ifsw=0;
;}
break;
case 165:
/* Line 1464 of yacc.c */
#line 1486 "grammar.y"
{
if (exitBuffer(BT_break)) YYERROR;
currentVoice->ifsw=0;
;}
break;
case 166:
/* Line 1464 of yacc.c */
#line 1491 "grammar.y"
{
if (contBuffer(BT_break)) YYERROR;
currentVoice->ifsw=0;
;}
break;
case 167:
/* Line 1464 of yacc.c */
#line 1499 "grammar.y"
{
/* -> if(!$2) break; $3; continue;*/
size_t len= strlen((yyvsp[(2) - (3)].name)) + strlen((yyvsp[(3) - (3)].name)) + 36;
char * s = (char *)omAlloc( len);
snprintf(s,len,"whileif (!(%s)) break;\n%scontinue;\n " ,(yyvsp[(2) - (3)].name),(yyvsp[(3) - (3)].name));
newBuffer(s,BT_break);
omFree((ADDRESS)(yyvsp[(2) - (3)].name));
omFree((ADDRESS)(yyvsp[(3) - (3)].name));
;}
break;
case 168:
/* Line 1464 of yacc.c */
#line 1512 "grammar.y"
{
/* $2 */
/* if (!$3) break; $5; $4; continue; */
size_t len= strlen((yyvsp[(3) - (5)].name))+strlen((yyvsp[(4) - (5)].name))+strlen((yyvsp[(5) - (5)].name))+36;
char *s=(char*)omAlloc(len);
snprintf(s,len,"forif (!(%s)) break;\n%s%s;\ncontinue;\n "
,(yyvsp[(3) - (5)].name),(yyvsp[(5) - (5)].name),(yyvsp[(4) - (5)].name));
omFree((ADDRESS)(yyvsp[(3) - (5)].name));
omFree((ADDRESS)(yyvsp[(4) - (5)].name));
omFree((ADDRESS)(yyvsp[(5) - (5)].name));
newBuffer(s,BT_break);
len=strlen((yyvsp[(2) - (5)].name)) + 3;
s = (char *)omAlloc( len);
snprintf(s,len,"%s;\n",(yyvsp[(2) - (5)].name));
omFree((ADDRESS)(yyvsp[(2) - (5)].name));
newBuffer(s,BT_if);
;}
break;
case 169:
/* Line 1464 of yacc.c */
#line 1533 "grammar.y"
{
idhdl h = enterid((yyvsp[(2) - (3)].name),myynest,PROC_CMD,&IDROOT,TRUE);
if (h==NULL) {omFree((ADDRESS)(yyvsp[(2) - (3)].name));omFree((ADDRESS)(yyvsp[(3) - (3)].name)); YYERROR;}
iiInitSingularProcinfo(IDPROC(h),"", (yyvsp[(2) - (3)].name), 0, 0);
int l=strlen((yyvsp[(3) - (3)].name))+31;IDPROC(h)->data.s.body = (char *)omAlloc(l);
snprintf(IDPROC(h)->data.s.body,l,"parameter list #;\n%s;return();\n\n",(yyvsp[(3) - (3)].name));
omFree((ADDRESS)(yyvsp[(3) - (3)].name));
omFree((ADDRESS)(yyvsp[(2) - (3)].name));
;}
break;
case 170:
/* Line 1464 of yacc.c */
#line 1543 "grammar.y"
{
idhdl h = enterid((yyvsp[(1) - (3)].name),myynest,PROC_CMD,&IDROOT,TRUE);
if (h==NULL)
{
omFree((ADDRESS)(yyvsp[(1) - (3)].name));
omFree((ADDRESS)(yyvsp[(2) - (3)].name));
omFree((ADDRESS)(yyvsp[(3) - (3)].name));
YYERROR;
}
char *args=iiProcArgs((yyvsp[(2) - (3)].name),FALSE);
omFree((ADDRESS)(yyvsp[(2) - (3)].name));
iiInitSingularProcinfo(IDPROC(h),"", (yyvsp[(1) - (3)].name), 0, 0);
int l=strlen((yyvsp[(3) - (3)].name))+strlen(args)+14;IDPROC(h)->data.s.body = (char *)omAlloc(l);
snprintf(IDPROC(h)->data.s.body,l,"%s\n%s;return();\n\n",args,(yyvsp[(3) - (3)].name));
omFree((ADDRESS)args);
omFree((ADDRESS)(yyvsp[(3) - (3)].name));
omFree((ADDRESS)(yyvsp[(1) - (3)].name));
;}
break;
case 171:
/* Line 1464 of yacc.c */
#line 1562 "grammar.y"
{
omFree((ADDRESS)(yyvsp[(3) - (4)].name));
idhdl h = enterid((yyvsp[(1) - (4)].name),myynest,PROC_CMD,&IDROOT,TRUE);
if (h==NULL)
{
omFree((ADDRESS)(yyvsp[(1) - (4)].name));
omFree((ADDRESS)(yyvsp[(2) - (4)].name));
omFree((ADDRESS)(yyvsp[(4) - (4)].name));
YYERROR;
}
char *args=iiProcArgs((yyvsp[(2) - (4)].name),FALSE);
omFree((ADDRESS)(yyvsp[(2) - (4)].name));
iiInitSingularProcinfo(IDPROC(h),"", (yyvsp[(1) - (4)].name), 0, 0);
omFree((ADDRESS)(yyvsp[(1) - (4)].name));
int l=strlen((yyvsp[(4) - (4)].name))+strlen(args)+14;IDPROC(h)->data.s.body = (char *)omAlloc(l);
snprintf(IDPROC(h)->data.s.body,l,"%s\n%s;return();\n\n",args,(yyvsp[(4) - (4)].name));
omFree((ADDRESS)args);
omFree((ADDRESS)(yyvsp[(4) - (4)].name));
;}
break;
case 172:
/* Line 1464 of yacc.c */
#line 1585 "grammar.y"
{
// decl. of type proc p(int i)
if ((yyvsp[(1) - (2)].i)==PARAMETER) { if (iiParameter(&(yyvsp[(2) - (2)].lv))) YYERROR; }
else { if (iiAlias(&(yyvsp[(2) - (2)].lv))) YYERROR; }
;}
break;
case 173:
/* Line 1464 of yacc.c */
#line 1591 "grammar.y"
{
// decl. of type proc p(i)
sleftv tmp_expr;
if ((yyvsp[(1) - (2)].i)==ALIAS_CMD) MYYERROR("alias requires a type");
if ((iiDeclCommand(&tmp_expr,&(yyvsp[(2) - (2)].lv),myynest,DEF_CMD,&IDROOT))
|| (iiParameter(&tmp_expr)))
YYERROR;
;}
break;
case 174:
/* Line 1464 of yacc.c */
#line 1603 "grammar.y"
{
iiSetReturn(&(yyvsp[(3) - (4)].lv));
(yyvsp[(3) - (4)].lv).CleanUp();
if (exitBuffer(BT_proc)) YYERROR;
;}
break;
case 175:
/* Line 1464 of yacc.c */
#line 1609 "grammar.y"
{
if ((yyvsp[(1) - (3)].i)==RETURN)
{
iiRETURNEXPR.Init();
iiRETURNEXPR.rtyp=NONE;
if (exitBuffer(BT_proc)) YYERROR;
}
;}
break;
/* Line 1464 of yacc.c */
#line 4252 "grammar.cc"
default: break;
}
YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);
YYPOPSTACK (yylen);
yylen = 0;
YY_STACK_PRINT (yyss, yyssp);
*++yyvsp = yyval;
/* Now `shift' the result of the reduction. Determine what state
that goes to, based on the state we popped back to and the rule
number reduced by. */
yyn = yyr1[yyn];
yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
yystate = yytable[yystate];
else
yystate = yydefgoto[yyn - YYNTOKENS];
goto yynewstate;
/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
/* If not already recovering from an error, report this error. */
if (!yyerrstatus)
{
++yynerrs;
#if ! YYERROR_VERBOSE
yyerror (YY_("syntax error"));
#else
{
YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
{
YYSIZE_T yyalloc = 2 * yysize;
if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
yyalloc = YYSTACK_ALLOC_MAXIMUM;
if (yymsg != yymsgbuf)
YYSTACK_FREE (yymsg);
yymsg = (char *) YYSTACK_ALLOC (yyalloc);
if (yymsg)
yymsg_alloc = yyalloc;
else
{
yymsg = yymsgbuf;
yymsg_alloc = sizeof yymsgbuf;
}
}
if (0 < yysize && yysize <= yymsg_alloc)
{
(void) yysyntax_error (yymsg, yystate, yychar);
yyerror (yymsg);
}
else
{
yyerror (YY_("syntax error"));
if (yysize != 0)
goto yyexhaustedlab;
}
}
#endif
}
if (yyerrstatus == 3)
{
/* If just tried and failed to reuse lookahead token after an
error, discard it. */
if (yychar <= YYEOF)
{
/* Return failure if at end of input. */
if (yychar == YYEOF)
YYABORT;
}
else
{
yydestruct ("Error: discarding",
yytoken, &yylval);
yychar = YYEMPTY;
}
}
/* Else will try to reuse lookahead token after shifting the error
token. */
goto yyerrlab1;
/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR. |
`---------------------------------------------------*/
yyerrorlab:
/* Pacify compilers like GCC when the user code never invokes
YYERROR and the label yyerrorlab therefore never appears in user
code. */
if (/*CONSTCOND*/ 0)
goto yyerrorlab;
/* Do not reclaim the symbols of the rule which action triggered
this YYERROR. */
YYPOPSTACK (yylen);
yylen = 0;
YY_STACK_PRINT (yyss, yyssp);
yystate = *yyssp;
goto yyerrlab1;
/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR. |
`-------------------------------------------------------------*/
yyerrlab1:
yyerrstatus = 3; /* Each real token shifted decrements this. */
for (;;)
{
yyn = yypact[yystate];
if (yyn != YYPACT_NINF)
{
yyn += YYTERROR;
if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
{
yyn = yytable[yyn];
if (0 < yyn)
break;
}
}
/* Pop the current state because it cannot handle the error token. */
if (yyssp == yyss)
YYABORT;
yydestruct ("Error: popping",
yystos[yystate], yyvsp);
YYPOPSTACK (1);
yystate = *yyssp;
YY_STACK_PRINT (yyss, yyssp);
}
*++yyvsp = yylval;
/* Shift the error token. */
YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);
yystate = yyn;
goto yynewstate;
/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here. |
`-------------------------------------*/
yyacceptlab:
yyresult = 0;
goto yyreturn;
/*-----------------------------------.
| yyabortlab -- YYABORT comes here. |
`-----------------------------------*/
yyabortlab:
yyresult = 1;
goto yyreturn;
#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here. |
`-------------------------------------------------*/
yyexhaustedlab:
yyerror (YY_("memory exhausted"));
yyresult = 2;
/* Fall through. */
#endif
yyreturn:
if (yychar != YYEMPTY)
yydestruct ("Cleanup: discarding lookahead",
yytoken, &yylval);
/* Do not reclaim the symbols of the rule which action triggered
this YYABORT or YYACCEPT. */
YYPOPSTACK (yylen);
YY_STACK_PRINT (yyss, yyssp);
while (yyssp != yyss)
{
yydestruct ("Cleanup: popping",
yystos[*yyssp], yyvsp);
YYPOPSTACK (1);
}
#ifndef yyoverflow
if (yyss != yyssa)
YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
if (yymsg != yymsgbuf)
YYSTACK_FREE (yymsg);
#endif
/* Make sure YYID is used. */
return YYID (yyresult);
}
TRUE
#define TRUE
Definition auxiliary.h:101
FALSE
#define FALSE
Definition auxiliary.h:97
ADDRESS
void * ADDRESS
Definition auxiliary.h:120
l
int l
Definition cfEzgcd.cc:100
i
int i
Definition cfEzgcd.cc:132
p
int p
Definition cfModGcd.cc:4086
b
CanonicalForm b
Definition cfModGcd.cc:4111
bigintmat
Matrices of numbers.
Definition bigintmat.h:51
idrec::get
idhdl get(const char *s, int lev)
Definition ipid.cc:70
intvec
Definition intvec.h:24
intvec::length
int length() const
Definition intvec.h:95
sleftv
Class used for (list of) interpreter objects.
Definition subexpr.h:83
sleftv::CopyD
void * CopyD(int t)
Definition subexpr.cc:714
sleftv::Typ
int Typ()
Definition subexpr.cc:1048
sleftv::Data
void * Data()
Definition subexpr.cc:1192
sleftv::next
leftv next
Definition subexpr.h:86
sleftv::CleanUp
void CleanUp(ring r=currRing)
Definition subexpr.cc:351
n_Read
static FORCE_INLINE const char * n_Read(const char *s, number *a, const coeffs r)
!!! Recommendation: This method is too cryptic to be part of the user- !!! interface....
Definition coeffs.h:601
Print
#define Print
Definition emacs.cc:80
Warn
#define Warn
Definition emacs.cc:77
s
const CanonicalForm int s
Definition facAbsFact.cc:51
v
const Variable & v
< [in] a sqrfree bivariate poly
Definition facBivar.h:39
j
int j
Definition facHensel.cc:110
name
char name(const Variable &v)
Definition factory.h:189
errorreported
VAR short errorreported
Definition feFopen.cc:23
WerrorS
void WerrorS(const char *s)
Definition feFopen.cc:24
myynest
VAR int myynest
Definition febase.cc:41
feHelp
void feHelp(char *str)
Definition fehelp.cc:90
prompt_char
EXTERN_VAR char prompt_char
Definition feread.h:10
exitBuffer
BOOLEAN exitBuffer(feBufferTypes typ)
Definition fevoices.cc:236
newBuffer
void newBuffer(char *s, feBufferTypes t, procinfo *pi, int lineno)
Definition fevoices.cc:166
contBuffer
BOOLEAN contBuffer(feBufferTypes typ)
Definition fevoices.cc:304
currentVoice
VAR Voice * currentVoice
Definition fevoices.cc:49
newFile
BOOLEAN newFile(char *fname)
Definition fevoices.cc:129
exitVoice
BOOLEAN exitVoice()
Definition fevoices.cc:341
feBufferTypes
feBufferTypes
Definition fevoices.h:17
BT_else
@ BT_else
Definition fevoices.h:25
BT_if
@ BT_if
Definition fevoices.h:24
BT_break
@ BT_break
Definition fevoices.h:19
BT_example
@ BT_example
Definition fevoices.h:21
BT_proc
@ BT_proc
Definition fevoices.h:20
iiTestConvert
int iiTestConvert(int inputType, int outputType)
Definition gentable.cc:298
iiTwoOps
const char * iiTwoOps(int t)
Definition gentable.cc:258
YYID
#define YYID(n)
Definition grammar.cc:439
yyr1
static const yytype_uint8 yyr1[]
Definition grammar.cc:821
YYLEX
#define YYLEX
Definition grammar.cc:1685
YYMAXDEPTH
#define YYMAXDEPTH
Definition grammar.cc:166
PLUSPLUS
@ PLUSPLUS
Definition grammar.cc:274
NOT
@ NOT
Definition grammar.cc:272
END_RING
@ END_RING
Definition grammar.cc:311
MINUSMINUS
@ MINUSMINUS
Definition grammar.cc:271
PARAMETER
@ PARAMETER
Definition grammar.cc:350
MATRIX_CMD
@ MATRIX_CMD
Definition grammar.cc:287
KEEPRING_CMD
@ KEEPRING_CMD
Definition grammar.cc:298
BIGINTMAT_CMD
@ BIGINTMAT_CMD
Definition grammar.cc:278
RETURN
@ RETURN
Definition grammar.cc:349
EQUAL_EQUAL
@ EQUAL_EQUAL
Definition grammar.cc:268
PROC_CMD
@ PROC_CMD
Definition grammar.cc:281
BEGIN_RING
@ BEGIN_RING
Definition grammar.cc:283
INTMAT_CMD
@ INTMAT_CMD
Definition grammar.cc:280
LIB_CMD
@ LIB_CMD
Definition grammar.cc:328
MODUL_CMD
@ MODUL_CMD
Definition grammar.cc:288
SMATRIX_CMD
@ SMATRIX_CMD
Definition grammar.cc:292
VECTOR_CMD
@ VECTOR_CMD
Definition grammar.cc:293
NOTEQUAL
@ NOTEQUAL
Definition grammar.cc:273
DOTDOT
@ DOTDOT
Definition grammar.cc:267
COLONCOLON
@ COLONCOLON
Definition grammar.cc:275
POLY_CMD
@ POLY_CMD
Definition grammar.cc:290
RING_CMD
@ RING_CMD
Definition grammar.cc:282
YYSTACK_FREE
#define YYSTACK_FREE
Definition grammar.cc:495
YY_SYMBOL_PRINT
#define YY_SYMBOL_PRINT(Title, Type, Value, Location)
Definition grammar.cc:1702
cmdtok
int cmdtok
Definition grammar.cc:174
expected_parms
BOOLEAN expected_parms
Definition grammar.cc:173
yyerrok
#define yyerrok
Definition grammar.cc:1589
currid
const char * currid
Definition grammar.cc:171
TESTSETINT
#define TESTSETINT(a, i)
Definition grammar.cc:177
YYEOF
#define YYEOF
Definition grammar.cc:1592
YYABORT
#define YYABORT
Definition grammar.cc:1595
yydefgoto
static const yytype_int16 yydefgoto[]
Definition grammar.cc:914
YY_REDUCE_PRINT
#define YY_REDUCE_PRINT(Rule)
Definition grammar.cc:1835
YYTABLE_NINF
#define YYTABLE_NINF
Definition grammar.cc:984
yypact
static const yytype_int16 yypact[]
Definition grammar.cc:926
MYYERROR
#define MYYERROR(a)
Definition grammar.cc:185
YYPACT_NINF
#define YYPACT_NINF
Definition grammar.cc:925
YYFINAL
#define YYFINAL
Definition grammar.cc:582
yypgoto
static const yytype_int16 yypgoto[]
Definition grammar.cc:971
yydestruct
static void yydestruct(const char *yymsg, int yytype, YYSTYPE *yyvaluep)
Definition grammar.cc:2089
YYNTOKENS
#define YYNTOKENS
Definition grammar.cc:587
YY_STACK_PRINT
#define YY_STACK_PRINT(Bottom, Top)
Definition grammar.cc:1797
YYSIZE_T
#define YYSIZE_T
Definition grammar.cc:410
YYSTACK_ALLOC_MAXIMUM
#define YYSTACK_ALLOC_MAXIMUM
Definition grammar.cc:497
YY_
#define YY_(msgid)
Definition grammar.cc:426
yyerror
void yyerror(const char *fmt)
Definition grammar.cc:187
yyInRingConstruction
BOOLEAN yyInRingConstruction
Definition grammar.cc:172
yytable
static const yytype_int16 yytable[]
Definition grammar.cc:985
yyr2
static const yytype_uint8 yyr2[]
Definition grammar.cc:844
YYACCEPT
#define YYACCEPT
Definition grammar.cc:1594
YYTRANSLATE
#define YYTRANSLATE(YYX)
Definition grammar.cc:599
yystos
static const yytype_uint8 yystos[]
Definition grammar.cc:1545
YYTERROR
#define YYTERROR
Definition grammar.cc:1634
YYPOPSTACK
#define YYPOPSTACK(N)
yytype_int16
short int yytype_int16
Definition grammar.cc:399
YYEMPTY
#define YYEMPTY
Definition grammar.cc:1591
YYLAST
#define YYLAST
Definition grammar.cc:584
YYINITDEPTH
#define YYINITDEPTH
Definition grammar.cc:1854
YYERROR
#define YYERROR
Definition grammar.cc:1596
yycheck
static const yytype_int16 yycheck[]
Definition grammar.cc:1264
YYSTACK_ALLOC
#define YYSTACK_ALLOC
Definition grammar.cc:494
YYDPRINTF
#define YYDPRINTF(Args)
Definition grammar.cc:1696
yydefact
static const yytype_uint8 yydefact[]
Definition grammar.cc:869
idDelete
#define idDelete(H)
delete an ideal
Definition ideals.h:29
inerror
EXTERN_VAR int inerror
Definition interpreter_support.cc:21
jjLOAD
BOOLEAN jjLOAD(const char *s, BOOLEAN autoexport)
load lib/module given in v
Definition iparith.cc:5591
iiExprArith2
BOOLEAN iiExprArith2(leftv res, leftv a, int op, leftv b, BOOLEAN proccall)
Definition iparith.cc:9176
iiExprArith1
BOOLEAN iiExprArith1(leftv res, leftv a, int op)
Definition iparith.cc:9365
iiExprArithM
BOOLEAN iiExprArithM(leftv res, leftv a, int op)
Definition iparith.cc:9666
iiExprArith3
BOOLEAN iiExprArith3(leftv res, int op, leftv a, leftv b, leftv c)
Definition iparith.cc:9575
iiAssign
BOOLEAN iiAssign(leftv l, leftv r, BOOLEAN toplevel)
Definition ipassign.cc:2099
iiConvert
BOOLEAN iiConvert(int inputType, int outputType, int index, leftv input, leftv output, const struct sConvertTypes *dConvertTypes)
Definition ipconv.cc:450
killhdl2
void killhdl2(idhdl h, idhdl *ih, ring r)
Definition ipid.cc:445
enterid
idhdl enterid(const char *s, int lev, int t, idhdl *root, BOOLEAN init, BOOLEAN search)
Definition ipid.cc:279
basePack
VAR package basePack
Definition ipid.cc:56
currPack
VAR package currPack
Definition ipid.cc:55
iiAlias
BOOLEAN iiAlias(leftv p)
Definition ipid.cc:841
killhdl
void killhdl(idhdl h, package proot)
Definition ipid.cc:414
IDMATRIX
#define IDMATRIX(a)
Definition ipid.h:134
IDNEXT
#define IDNEXT(a)
Definition ipid.h:118
sleftv_bin
EXTERN_VAR omBin sleftv_bin
Definition ipid.h:145
IDPROC
#define IDPROC(a)
Definition ipid.h:140
IDINTVEC
#define IDINTVEC(a)
Definition ipid.h:128
IDBIMAT
#define IDBIMAT(a)
Definition ipid.h:129
IDIDEAL
#define IDIDEAL(a)
Definition ipid.h:133
IDID
#define IDID(a)
Definition ipid.h:122
IDROOT
#define IDROOT
Definition ipid.h:19
IDLEV
#define IDLEV(a)
Definition ipid.h:121
IDRING
#define IDRING(a)
Definition ipid.h:127
iiProcArgs
char * iiProcArgs(char *e, BOOLEAN withParenth)
Definition iplib.cc:114
iiRETURNEXPR
INST_VAR sleftv iiRETURNEXPR
Definition iplib.cc:483
iiLocalRing
VAR ring * iiLocalRing
Definition iplib.cc:482
iiInitSingularProcinfo
procinfo * iiInitSingularProcinfo(procinfov pi, const char *libname, const char *procname, int, long pos, BOOLEAN pstatic)
Definition iplib.cc:1059
iiParameter
BOOLEAN iiParameter(leftv p)
Definition ipshell.cc:1384
iiDeclCommand
int iiDeclCommand(leftv sy, leftv name, int lev, int t, idhdl *root, BOOLEAN isring, BOOLEAN init_b)
Definition ipshell.cc:1206
rKill
void rKill(ring r)
Definition ipshell.cc:6181
iiApply
BOOLEAN iiApply(leftv res, leftv a, int op, leftv proc)
Definition ipshell.cc:6431
list_cmd
void list_cmd(int typ, const char *what, const char *prefix, BOOLEAN iterate, BOOLEAN fullname)
Definition ipshell.cc:426
rInit
ring rInit(leftv pn, leftv rv, leftv ord)
Definition ipshell.cc:5628
iiARROW
BOOLEAN iiARROW(leftv r, char *a, char *s)
Definition ipshell.cc:6480
exprlist_length
int exprlist_length(leftv v)
Definition ipshell.cc:551
iiTestAssume
BOOLEAN iiTestAssume(leftv a, leftv b)
Definition ipshell.cc:6453
iiSetReturn
void iiSetReturn(const leftv source)
Definition ipshell.cc:6634
iiAssignCR
BOOLEAN iiAssignCR(leftv r, leftv arg)
Definition ipshell.cc:6515
rFindHdl
idhdl rFindHdl(ring r, idhdl n)
Definition ipshell.cc:1701
iiDebug
void iiDebug()
Definition ipshell.cc:1073
lastreserved
const char * lastreserved
Definition ipshell.cc:83
type_cmd
void type_cmd(leftv v)
Definition ipshell.cc:255
rSetHdl
void rSetHdl(idhdl h)
Definition ipshell.cc:5129
iiExport
BOOLEAN iiExport(leftv v, int toLev)
Definition ipshell.cc:1510
singular_example
void singular_example(char *str)
Definition misc_ip.cc:431
h
STATIC_VAR Poly * h
Definition janet.cc:971
next
ListNode * next
Definition janet.h:31
mpNew
matrix mpNew(int r, int c)
create a r x c zero-matrix
Definition matpol.cc:37
MAX_INT_LEN
const int MAX_INT_LEN
Definition mylimits.h:13
omAlloc
#define omAlloc(size)
Definition omAllocDecl.h:210
omAllocBin
#define omAllocBin(bin)
Definition omAllocDecl.h:205
omFree
#define omFree(addr)
Definition omAllocDecl.h:261
NULL
#define NULL
Definition omList.c:12
siCntrlc
VAR BOOLEAN siCntrlc
Definition options.c:14
BVERBOSE
#define BVERBOSE(a)
Definition options.h:35
V_REDEFINE
#define V_REDEFINE
Definition options.h:45
coeffs_BIGINT
VAR coeffs coeffs_BIGINT
Definition polys.cc:14
currRing
VAR ring currRing
Widely used global variable which specifies the current polynomial ring for Singular interpreter and ...
Definition polys.cc:13
pAdd
#define pAdd(p, q)
Definition polys.h:204
pDelete
#define pDelete(p_ptr)
Definition polys.h:187
pSetCompP
#define pSetCompP(a, i)
Definition polys.h:304
yynerrs
int yynerrs
Definition readcf.cc:927
yychar
int yychar
Definition readcf.cc:922
PrintLn
void PrintLn()
Definition reporter.cc:314
Werror
void Werror(const char *fmt,...)
Definition reporter.cc:189
rOrderName
rRingOrder_t rOrderName(char *ordername)
Definition ring.cc:512
rDefault
ring rDefault(const coeffs cf, int N, char **n, int ord_size, rRingOrder_t *ord, int *block0, int *block1, int **wvhdl, unsigned long bitmask)
Definition ring.cc:103
idhdl
idrec * idhdl
Definition ring.h:22
sdb_flags
VAR int sdb_flags
Definition sdb.cc:31
idInit
ideal idInit(int idsize, int rank)
initialise an ideal / module
Definition simpleideals.cc:35
leftv
sleftv * leftv
Definition structs.h:53
YYSTYPE
#define YYSTYPE
Definition stype.h:19
yylval
EXTERN_VAR YYSTYPE yylval
Definition stype.h:20
syMake
void syMake(leftv v, const char *id, package pa)
Definition subexpr.cc:1613
sLastPrinted
INST_VAR sleftv sLastPrinted
Definition subexpr.cc:46
siq
VAR BOOLEAN siq
Definition subexpr.cc:48
syMakeMonom
void syMakeMonom(leftv v, const char *id)
Definition subexpr.cc:1917
writeRTime
void writeRTime(const char *v)
Definition timer.cc:173
startTimer
int startTimer()
Definition timer.cc:66
rtimerv
VAR int rtimerv
Definition timer.cc:126
writeTime
void writeTime(const char *v)
Definition timer.cc:101
timerv
VAR int timerv
Definition timer.cc:17
startRTimer
void startRTimer()
Definition timer.cc:131
IDHDL
#define IDHDL
Definition tok.h:31
NONE
#define NONE
Definition tok.h:223
COMMAND
#define COMMAND
Definition tok.h:29
UNKNOWN
#define UNKNOWN
Definition tok.h:224

## Variable Documentation

## my_yylinebuf

EXTERN_VAR char my_yylinebuf[80]

Definition at line 16 of file tok.h.

## yylineno

EXTERN_VAR int yylineno

Definition at line 15 of file tok.h.